/* prngconfig.h 
 *
 * Compile-time options for module PRNG.
 *
 * vi: set tabstop=4 shiftwidth=4:
 * 
 * $Id: prngconfig.h,v 1.3 1997/12/18 18:25:07 neto Exp neto $
 * 
 *    Copyright (C) 1997 David Neto
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful, but
 *    WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *    USA.
 * 
 * 
 * This file sets the compile-time options for module PRNG.
 * or availability of certain parts of the program LK are enabled or
 * modified here by defining C preprocessor symbols.  The defaults are
 * given in comments.
 * 
 * Warning!  This file is *not* generated by a web file.  It is a plain .h
 * header file so that the user who doesn't have ctangle installed (tsk,
 * tsk!) has the ability to change the configuration options for the
 * program LK.  That said, I've tried to make this file as self-documenting
 * as possible without the power of CWEB or TeX.
 * 
 */


/* Sometimes small procedures are expanded in-place in order to save the
 * time overhead of a function call and return.  That is called inlining.
 *
 * However, inlining usually expands code, possibly causing the instruction 
 * cache to be less effective.  In those cases, inlining can slow down the
 * code.  Hence the choice.
 *
 * If PRNG_DESIRE_INLINING is non-zero, then use inlining if the compiler 
 * supports it.
 *
 * Well, it seems that inlining slows down the code a whole lot on a SPARC,
 * but speeds things up on my Intel 486 Linux box. 
 */

#if defined(__sparc__)
#define PRNG_DESIRE_INLINING 0
#else
#define PRNG_DESIRE_INLINING 1
#endif
