@i myboiler.w

\noindent Copyright \copyright 1994, 1995, 1996, 1997, 1998 David Neto
\smallskip

\noindent 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
\smallskip

\noindent 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
\smallskip

\noindent   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA  02111-1307, USA.
\smallskip

\noindent   
   You may contact David Neto via email at {\tt netod@@acm.org}, or with
   greater latency at
\smallskip
\noindent{\obeylines
     Department of Computer Science
     University of Toronto
     10 King's College Rd.
     Toronto, Ontario
     M5S 3G4
     Canada
}
\medskip


\noindent\hbox{}\hrule\hbox{}\penalty-1000
\vskip0.5cm\relax



@i webdefs.w
@i types.w

{\obeylines
$Log: read.w,v $
Revision 1.142  1998/10/10 19:26:20  neto
Support DSJ RANDOM, ATT, and GEO
Better error messages.

Revision 1.141  1998/10/08 15:14:47  neto
Allow clipping of last point on output too.

Revision 1.140  1998/07/31 17:56:24  neto
Doh!  needed a break too.

Revision 1.139  1998/07/31 17:51:53  neto
added default: to satisfy GCC's complaint about missing RANDOM EDGES
in a switch.

Revision 1.138  1998/07/25 22:10:34  neto
Remove the lexicographically last vertex.

Revision 1.137  1998/07/25 18:10:50  neto
Some of forcing even number of vertic3s.

Revision 1.136  1998/07/24 20:38:33  neto
Added changes to allow truncating the odd vertex out.
Not finished.

Revision 1.135  1998/07/16 21:58:55  neto
Added the LGPL notice in each file.

Revision 1.134  1998/05/08 22:23:57  neto
Better comment.
Also, added writing abilities for matrix forms.

Revision 1.133  1997/12/13 20:05:45  neto
Ok, so I got the name of write... wrong

Revision 1.132  1997/12/13 20:03:05  neto
Added first (compiling) draft of write tsp instance

Revision 1.131  1997/12/13 17:25:18  neto
Stripped the newlines off the error messages.

Revision 1.130  1997/10/18 15:16:19  neto
More readability (matchword).
Hopefully fix garbage output on error (move keyword[0]=0).
Added support for CEIL 2D

Revision 1.129  1997/10/17  21:47:44  neto
Fixed to compile.

Revision 1.128  1997/10/17  21:00:25  neto
Made coordinates indexed by number, not name, i.e. x[0] and x[1] instead
of x and y.  This reduces the code size in kdtree by removing
the CUTDIMEN kludge.

Revision 1.127  1997/09/27 18:04:39  neto
Fixed RCS log behaviour

Revision 1.126  1997/08/15  20:18:25  neto
Added Index major section.

Revision 1.125  1997/05/16  18:11:41  neto
Break locks by david and neto.
Include <config.h> and "lkconfig.h"

Revision 1.124  1997/05/16  18:09:40  neto
Include <config.h> and lkconfig.h

Revision 1.123  1997/02/10  19:25:03  neto
Limit the size of the PostScript arrays.

Revision 1.122  1997/02/10  19:16:26  neto
Fixed printf spec.

Revision 1.121  1997/02/10  19:13:51  neto
Changed debugging PostScript output so that we don't depend on
large (>8191 element) arrays.

Revision 1.120  1997/01/21  21:55:55  david
Added standard copyright notice by including copyrt.w

Revision 1.119  96/12/20  14:02:47  neto
Make EOF optional. 

Revision 1.118  96/12/13  17:11:23  neto
Make hypot optional.

Revision 1.117  96/12/13  14:44:43  neto
Used hypot instead of sqrt.
Also, added cost\_from\_euc2d\_raw.

Revision 1.116  96/12/05  14:43:16  neto
Added support for no rounding.

Revision 1.115  96/09/12  15:25:37  neto
Empty input doesn't print a garbage keyword now.

Revision 1.114  96/08/16  13:05:01  neto
Added fixincludes.

Revision 1.113  96/08/15  14:01:29  neto
Make it pass all flags, except for error problem.

Revision 1.112  96/08/15  12:34:25  neto
Make it pass -Wall

Revision 1.111  96/07/29  17:07:58  neto
Fixed to compile.

Revision 1.110  96/07/29  16:24:28  neto
oops.  TeX again.

Revision 1.109  96/07/29  16:22:58  neto
TeX barfed on the Log.

Revision 1.108  96/07/29  16:20:09  neto
Added *\_rcs\_id.
Made sure RCS log is activated within this file.

}

@*Reading TSPLIB files.
The {\sc READ\_ME} included with {\sc TSPLIB} describes the file format.
We restrict our attention to the case where the arc lengths are given
in matrix form, or are assumed to be the Euclidean lengths in two dimensions.

Here is the outline of this module.

@c
#include <config.h>
#include "lkconfig.h"
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <math.h>
#include "fixincludes.h"
@<Other includes@>@;

#include "read.h"

@<Global variables@>@;
@<Module definitions@>@;
@<Module variables@>@;
@<Module subroutines@>@;
@<Subroutines@>@;
const char *read_rcs_id="$Id: read.w,v 1.142 1998/10/10 19:26:20 neto Exp neto $";


@ The header file for this module is also included into this module.
It provides type definitions and declarations of publicly accessible
variables and subroutines.

@(read.h@>=
extern const char *read_rcs_id;
@<Type definitions@>@;
@<Exported variables@>@;
@<Exported subroutines@>@;


@ These routines deal with only one problem at a time.  
We keep a pointer to the current problem in the variable |p|.
This is convenient to the users of these routines because that means
they don't have to pass an extra pointer on every function call.
This is also more efficient because we expect the edge cost function
to be evaluated thousands and maybe millions of times.

@<Global variables@>=
static tsp_instance_t *p;

@ We provide a mechanism to switch contexts.  
The user supplies the
problem that becomes the new context, and receives the current
context.

@<Subroutines@>=
tsp_instance_t *
switch_to(tsp_instance_t *new_problem) 
{
	tsp_instance_t *old_problem;
	old_problem = p;
	p = new_problem;
	@<Set the |cost| function according to the current context@>@;
	return old_problem;
}

@ The switching routine is made publicly available.
@<Exported subroutines@>=
tsp_instance_t *
switch_to(tsp_instance_t *new_problem);

@ The routine that actually does the reading is passed the file name
and fills the current context.  If a previous context exists, then
it should be saved with a call such as |saved_problem = switch_to(NULL)|, 
or it should be freed.


@<Subroutines@>=
tsp_instance_t *
read_tsp_file(FILE *in, FILE *debug, const int force_even_num)
{
	p=new_of(tsp_instance_t);
	@<Set the instance defaults@>@;
	@<Read in the instance@>@;
	@<Check consistency@>@;
	@<Possibly remove a vertex@>@;
	@<Debugging output@>@;
	return p;
}

@ We've used an allocation macro, so we should include the header file
where it is defined.  We also need to know the error checking interface.
@<Other includes@>=
#include "memory.h"
#include "error.h"

@ We make the reading routine publicly available.
@<Exported subroutines@>=
tsp_instance_t *read_tsp_file(FILE *in, FILE *out, const int remove_odd_vertex);


@ The |tsp_instance_t| type contains fields that identify and 
specify the problem.

The |name| field is the name given by the TSPLIB maintainers to this problem.
It is useful as a basename for the file, though we don't enforce such
usage.  

The |comment| field is the one-line comment attached to this graph.

The |n| field is the number of cities in the instance.  
Some problems, such as weighted perfect matching, require the graph
to have an even number of vertices.  In that case after reading in the
full instance, we might remove one vertex.  We store the number of
vertices presented on the input in the field |input_n|:
it might be odd and 1 more than |n|.

The |scale| entry is used to scale random edge lengths.  So far it
is used only by |DSJ_RANDOM|-type instances.

@<Type definitions@>=
@<Early type definitions@>@;
typedef struct {
	char *name;
	char *comment;
	int n;
	int input_n;
	double scale;
	double dsj_random_factor;
	double dsj_random_param;
	@<Other |tsp_instance_t| fields@>@;
} tsp_instance_t;

@ We specify defaults for these fields so that if there is a problem
reading the file, we can detect it later on.

@<Set the instance defaults@>=
p->name = NULL;
p->comment = NULL;
p->n = 0;
p->scale = 1e6;

@ The different parts of the input file are introduced by various keywords.
So we read a keyword, and then do the appropriate thing.

@d matchword(STR) (0==strncmp(keyword,STR,strlen(STR)))
	
@<Read in the instance@>=
{
#define MAX_KEYWORD_LEN (25)
#define MAX_LINE_LEN (200)
char keyword[MAX_KEYWORD_LEN], rest_of_line[MAX_LINE_LEN];
int more_input = 1, lineno=0;
while( more_input) {
	char *colon; int r;
	keyword[0]=0;
	r = fscanf(in," %s ", keyword); 
	if ( r==EOF )@+ {@+more_input=0;@+break;@+}
	errorif( r != 1, "%d: Couldn't read the word following \"%s\". (r==%d)",
			 lineno+1,keyword,r);
	if ( NULL!=(colon = strchr(keyword,':')) ) *colon = '\0';
	if ( matchword("EOF") ) {
		more_input = 0;
	}@+ else if ( matchword("NAME") ) {
		@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
		p->name = dup_string(rest_of_line);@;
	}@+ else if ( matchword("COMMENT") ) {
		@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
		p->comment = dup_string(rest_of_line);@;
	}@+ else if ( matchword("TYPE") ) {
		@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
		errorif(strcmp(rest_of_line,"TSP"),"Can't read TSPLIB files of type %s.",rest_of_line);@;
	}@+ else if ( matchword("DIMENSION") ) {
		@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
		p->input_n = p->n = atoi(rest_of_line);
	}@+ else if ( matchword("DISPLAY_DATA_TYPE") ) {
		@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
		/* Do nothing. */
	}@+ else if ( matchword("EDGE_WEIGHT_TYPE") ) {
		@<Parse the edge weight type@>@;
	}@+ else if ( matchword("EDGE_WEIGHT_FORMAT") ) {
		@<Parse the edge weight format@>@;
	}@+ else if ( matchword("EDGE_WEIGHT_SECTION") ) {
		@<Parse the edge weights@>@;
	}@+ else if ( matchword("NODE_COORD_SECTION") ) {
		@<Parse the node coordinates@>@;
	}@+ else if ( matchword("DISPLAY_DATA_SECTION") ) {
		@<Parse the display data@>@;
	}@+ else if ( matchword("SEED") ) {
		@<Set the seed and possibly generate edge lengths@>@;
	}@+ else if ( matchword("SCALE") ) {
		@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
		p->scale = atof(rest_of_line);
		p->dsj_random_factor = p->scale/2147483648.0;
	}@+ else {
		@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
		errorif(1,"%d: Don't know what the keyword %s is!",lineno,keyword);
	}
}
@<Set the |cost| function according to the current context@>@;
}

@ We need to include the interface definition for the string handling
functions.
@<Other includes@>=
#include <string.h>

@
We make sure that the colon is actually there, and that the line
lengths aren't violated.

Also, erase trailing whitespace.

@<Get the rest of the line into |rest_of_line|, but skip the colon@>=
{ 
int l; char *rcp;
if ( colon == NULL ) {
	int r=fscanf(in," : ");
	errorif( r != 0, "%d: Missed the colon.", lineno);
}
rcp = fgets(rest_of_line,MAX_LINE_LEN,in);
errorif( NULL == rcp,
	@|"%d: Couldn't read after the colon; truncated file?", lineno);@;
l = strlen(rest_of_line)-1;@;
if ( l>=0 && rest_of_line[l] == '\n' ) { rest_of_line[l--]='\0'; lineno++;}
while ( l >= 0 && isspace(rest_of_line[l]) ) rest_of_line[l--] = '\0';@;
if ( feof(in) )@+more_input = 0;
}

@ We need to include the character classifiction macros.
@<Other includes@>=
#include <ctype.h>

@ The |RANDOM_EDGES| edge weight type is an extension to the TSPLIB format.  
It specifies that the edge lengths should be random and uniformly
distributed between 1 and 1000.  The keyword |SEED| must be used
to specify a seed value and to generate the edge lengths.

@<Parse the edge weight type@>=
@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
if ( 0==strcmp(rest_of_line,"EUC_2D") ) {
	p->edge_weight_type = EUC_2D;
}@+else if ( 0==strcmp(rest_of_line,"CEIL_2D") ) {
	p->edge_weight_type = CEIL_2D;
}@+else if ( 0==strcmp(rest_of_line,"GEO") ) {
	p->edge_weight_type = GEO;
}@+else if ( 0==strcmp(rest_of_line,"ATT") ) {
	p->edge_weight_type = ATT;
}@+else if ( 0==strcmp(rest_of_line,"DSJ_RANDOM") ) {
	p->edge_weight_type = DSJ_RANDOM;
}@+else if ( 0==strcmp(rest_of_line,"EXPLICIT") ) {
	p->edge_weight_type = EXPLICIT;
}@+else if ( 0==strcmp(rest_of_line,"RANDOM_EDGES") ) {
	p->edge_weight_type = RANDOM_EDGES;
}@+else {
	errorif(1,"%d: Apology: Unknown edge weight type \"%s\".",lineno,rest_of_line);
}

@ @<Early type definitions@>=
typedef enum 
{ NO_EDGE_TYPE, EUC_2D, CEIL_2D, GEO, ATT, DSJ_RANDOM, EXPLICIT, RANDOM_EDGES } edge_weight_type_t;

@ 
@<Module variables@>=
static const char edge_weight_type_name[] =
{ "NO_EDGE_TYPE", "EUC_2D", "CEIL_2D", "GEO", "ATT", "DSJ_RANDOM", "EXPLICIT", "RANDOM_EDGES"};

@ @<Other |tsp_instance_t| fields@>=
edge_weight_type_t edge_weight_type;

@ @<Set the instance defaults@>=
p->edge_weight_type = NO_EDGE_TYPE;

@ @<Other includes@>=
#include "gb_flip.h"




@ @<Parse the edge weight format@>=
@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
if ( 0==strcmp(rest_of_line,"LOWER_DIAG_ROW") ) {
	p->edge_weight_format = LOWER_DIAG_ROW;
}@+else if ( 0==strcmp(rest_of_line,"FULL_MATRIX") ) {
	p->edge_weight_format = FULL_MATRIX;
}@+else if ( 0==strcmp(rest_of_line,"UPPER_ROW") ) {
	p->edge_weight_format = UPPER_ROW;
}@+else {
	errorif(1,"%d: Unknown edge weight format \"%s\".",lineno,rest_of_line);
}

@ @<Early type definitions@>=
typedef enum { NO_EDGE_FORMAT, LOWER_DIAG_ROW, FULL_MATRIX, UPPER_ROW } 
	edge_weight_format_t;

@ 
@<Module variables@>=
static const char edge_weight_format_name[] =
{ "NO_EDGE_FORMAT", "LOWER_DIAG_ROW", "FULL_MATRIX", "UPPER_ROW"};

@ @<Other |tsp_instance_t| fields@>=
edge_weight_format_t edge_weight_format;

@ @<Set the instance defaults@>=
p->edge_weight_format = NO_EDGE_FORMAT;


@*Explicit edge weights.
We parse the edge weights according to the format they are given.  The
file format guarantees that we know this information before this section
arrives.

@<Parse the edge weights@>=
switch( p->edge_weight_format ) {
long int long_dummy;
case LOWER_DIAG_ROW :
	{ 
		int row, col;
		p->edge_weights = new_arr_of(length_t*,p->input_n);
			/* Allocate the space for the edge weights. */
		for ( row = 0 ; row < p->input_n ; row++ ) {
			p->edge_weights[row] = new_arr_of(length_t,p->input_n);
		}
		for ( row = 0 ; row < p->input_n ; row++ ) { /* Now actually read the weights. */
			for ( col = 0 ; col <= row ; col++ ) {
				int r= fscanf(in," %ld ", &long_dummy);
				errorif( 1 != r,
					"Couldn't convert an edge weight: %d to %d.",row+1,col+1);
				p->edge_weights[col][row] = p->edge_weights[row][col] = long_dummy;
			}
		}
	}
	break;
case FULL_MATRIX :
	{
		int row, col;
		p->edge_weights = new_arr_of(length_t*,p->input_n);
			/* Allocate the space for the edge weights. */
		for ( row = 0 ; row < p->input_n ; row++ ) {
			p->edge_weights[row] = new_arr_of(length_t,p->input_n);
		}
		for ( row = 0 ; row < p->input_n ; row++ ) { /* Now actually read the weights. */
			for ( col = 0 ; col < p->input_n ; col++ ) {
				int r= fscanf(in," %ld ", &long_dummy);
				errorif( 1 != r,
					"Couldn't convert an edge weight: %d to %d.",row+1,col+1);
				p->edge_weights[row][col] = long_dummy;
			}
		}
		for ( row = 0; row < p->input_n ; row++ ) {
			for ( col = 0; col < row ; col++ ) {
				errorif(p->edge_weights[row][col] != p->edge_weights[col][row],
					"Asymmetric FULL_MATRIX:  (%d,%d) does not match (%d,%d)",
					row,col,col,row);
			}
		}
	}
	break;
case UPPER_ROW:
	{ 
		int row, col;
		p->edge_weights = new_arr_of(length_t*,p->input_n);
			/* Allocate the space for the edge weights. */
		for ( row = 0 ; row < p->input_n ; row++ ) {
			p->edge_weights[row] = new_arr_of(length_t,p->input_n);
			p->edge_weights[row][row] = 0;
		}
		for ( row = 0 ; row < p->input_n ; row++ ) { 
			/* Now actually read the weights. */
			for ( col = row+1 ; col < p->input_n ; col++ ) {
				int r= fscanf(in," %ld ", &long_dummy);
				errorif( 1 != r,
					"Couldn't convert an edge weight: %d to %d.",row+1,col+1);
				p->edge_weights[col][row] = p->edge_weights[row][col] = long_dummy;
			}
		}
	}
	break;
default: break;
}

@ We need the |length_t| type.
@<Other includes@>=
#include "length.h"

@ @<Other |tsp_instance_t| fields@>=
length_t **edge_weights;

@ @<Set the instance defaults@>=
p->edge_weights = NULL;


@*Implicit edge weights.
In this case, the weights of the edges are not given explicitly in
the file, and we don't store them either.  Instead, each weight can
be computed from other data given in the file, usually coordinates
of the vertices of the problem.  

Currently the only implicit edge weight scheme we support is the
two-dimensional Euclidean distance.  
Unsupported schemes include
the geographical distances.

Beware of off-by-one errors in input and output:
the input format counts from 1; we count from 0.

For the purposes of graphical output, we also keep track of the bounding
box of the cities.

@d min(X,Y) ((X)>(Y)?(Y):(X))
@d max(X,Y) ((X)<(Y)?(Y):(X))
@d check_num_read(R,K) 
	errorif((R)!=(K),"Error: expected %d arguments, got %d",K,R)

@<Parse the node coordinates@>=
{
	int i,j, r;
	p->coord = new_arr_of(coord_2d,p->input_n);	/* Allocate the space for the coordinates. */
	for ( i=0; i<p->input_n; i++ ) {
		r = fscanf(in," %d ",&j);  
		check_num_read(r,1);
		r = fscanf(in," %lf %lf ",&p->coord[j-1].x[0],&p->coord[j-1].x[1]);
		check_num_read(r,2);
		p->xmin = min(p->xmin,p->coord[j-1].x[0]);
		p->ymin = min(p->ymin,p->coord[j-1].x[1]);
		p->xmax = max(p->xmax,p->coord[j-1].x[0]);
		p->ymax = max(p->ymax,p->coord[j-1].x[1]);
		lineno++;
	}
}

@ Index |0| refers to the $x$ coordinate,
and index |1| refers to the $y$ coordinate.

I use an array because code that indexes can be made shorter than
code that uses different names.  Also, it generalizes more easily
to higher dimensions.  As a bonus, a good compiler ought to emit identical
anyway.

@<Early type definitions@>=
typedef struct { double x[2]; } coord_2d;

@ @<Other |tsp_instance_t| fields@>=
coord_2d *coord;
double xmin, xmax, ymin, ymax;

@ I've used the limits on integer values for the minimum and maximum
coordinate values.  It would be nice to use |double|-valued constants,
but I can't seem to find them under SunOS.  (Header {\tt math.h} has
|HUGE_VAL|, but that appears to be an infinity; it breaks on the KSR.)
In any case, these integer values should be good enough.

@<Set the instance defaults@>=
p->coord = NULL;
p->xmin = p->ymin = INT_MAX;
p->xmax = p->ymax = INT_MIN;

@ @<Other includes@>=
#include <limits.h>

@ Currently we don't do anything with the display coordinates.  
In the future, we may want to output PostScript.
@<Parse the display data@>=
{ 	
	int i;
	double dummy;
	for ( i=0; i<p->input_n; i++ ) {
		fscanf(in," %lf %lf %lf ",&dummy,&dummy,&dummy);
	}
}

@ The random seed can be used in one of two ways.  Either we can 
generate all the edges in advance (in case |RANDOM_EDGES|) or
on the fly (in case |DSJ_RANDOM|).  The latter case saves us 
a whole whack of space ---quadratic in the number of vertices---
and therefore can reasonably used for instances with 
upwards of a hundred thousand
vertices.

@<Set the seed and possibly generate edge lengths@>=
@<Get the rest of the line into |rest_of_line|, but skip the colon@>@;
p->seed = atol(rest_of_line);
switch(p->edge_weight_type) {
case DSJ_RANDOM: /* Don't do anything now. */
	p->dsj_random_param = 1+104*p->seed;
	break;
case RANDOM_EDGES:
	@<Generate random edge lengths using the given seed@>@;
	break;
default: 
	errorif(1,"SEED directive used for edge type %s",
			edge_weight_type_name[p->edge_weight_type]);
}

@ The seed is part of the instance structure.
@<Other |tsp_instance_t| fields@>=
long seed;

@ @<Set the instance defaults@>=
p->seed = 1;
p->dsj_random_factor=1.0;
p->dsj_random_param=1;

@
@<Module variables@>=
static double dsj_random_factor=1;
static int32 dsj_random_param=1;

@ We use |short|s to store the randomly generated edge lengths because
they fit.  This scheme saves space and time because of cache effects.

@<Generate random edge lengths using the given seed@>=
gb_init_rand( p->seed );
{ int i,j;
p->short_edge_weights = new_arr_of(short*,p->input_n);
for (i=0;i<p->input_n;i++) {
	p->short_edge_weights[i]  = new_arr_of(short,p->input_n);
	p->short_edge_weights[i][i] = 0;
}
for (i=0;i<p->input_n;i++)
	for (j=0;j<i;j++) 
		p->short_edge_weights[i][j] = p->short_edge_weights[j][i] = 
			(short)(1+gb_unif_rand(1000L));
if ( p->input_n <=10 ) {
	printf("Cost matrix:\n");
	for (i=0;i<p->input_n;i++) {
		for (j=0;j<p->input_n;j++) printf(" %4d",p->short_edge_weights[i][j]);
		printf("\n");
	}
}
}

@ @<Other |tsp_instance_t| fields@>=
short **short_edge_weights;

@ @<Set the instance defaults@>=
p->short_edge_weights = NULL;

@*Cost functions.
The cost function depends upon the type of the current problem.
The |cost| variable is a function pointer that refers to the appropriate
function, and it is always the case that 
|cost(i,j)| is the cost of the edge from |i| to |j| in the current problem.

We will often only be comparing the lengths of a pair of edges.
In these cases, we can substitute a function which is monotonic
in the real cost function.  
The |pseudo_cost| function should be monotonic in |cost|.
That is,
$${\mit cost}(i,j)\le {\mit cost}(k,l) \iff
{\mit pseudo\_cost}(i,j) \le {\mit pseudo\_cost}(k,l).$$
%$$ |cost(i,j)|\le|cost(k,l)|\iff
%|pseudo_cost(i,j)|\le|pseudo_cost(k,l)|.$$

@<Global variables@> =
length_t (*cost)(const int,const int);
length_t (*pseudo_cost)(const int,const int);

@ We make this variable known to the outside world.
@<Exported variables@>=
extern length_t (*cost)(const int,const int);
extern length_t (*pseudo_cost)(const int,const int);


@ When the edge weights are given explicitly, the cost function is merely
a table lookup.  When the edge lengths are generated randomly, they
save space
@<Module subroutines@>=
length_t cost_from_matrix(const int i,const int j);

length_t
cost_from_matrix(const int i,const int j)
{
	return (length_t)p->edge_weights[i][j];
}

length_t cost_from_short_matrix(const int i, const int j);

length_t
cost_from_short_matrix(const int i, const int j)
{
	return (length_t)p->short_edge_weights[i][j];
}


@ We use the following cost function when the weight of an edge weights between
two nodes is the two dimensional Euclidean distance between those nodes.

The original incarnation of the TSPLIB documentation used the |aint| 
function in place of the |floor| 
function.  However, |aint| is not in any ANSI~C standard library.  
For non-negative arguments, |aint| and |floor| behave the same way: each
returns
a |double| value representing the greatest integer not more than its |double|
argument.
(I compared the |aint| manual page under SunOS~4.1 dated 15 October 1987
with the description of |floor| in Plauger's {\sl The Standard C Library}.)

The newer documentation uses |nint| which also isn't in the ANSI~C library.
I believe it is the same ``round to the nearest integer'', which I take
to mean |nint(\alpha)=floor(\alpha)|.


Maybe we should be more intelligent about integer square roots???

@<Module subroutines@>=
length_t cost_from_euc2d(const int i, const int j);
length_t
cost_from_euc2d(const int i, const int j)
{
	coord_2d *coord_array = p->coord;
	double xd = coord_array[i].x[0] - coord_array[j].x[0];
	double yd = coord_array[i].x[1] - coord_array[j].x[1];
	return (length_t) floor(0.5+my_hypot(xd,yd));
}

@ Taking the ceiling instead of just rounding to the nearest integer
is interesting because the Euclidean distance with ceiling is a metric.
In particular, the triangle inequality is preserved under taking ceilings.

@<Module subroutines@>=
length_t cost_from_ceil2d(const int i, const int j);
length_t
cost_from_ceil2d(const int i, const int j)
{
	coord_2d *coord_array = p->coord;
	double xd = coord_array[i].x[0] - coord_array[j].x[0];
	double yd = coord_array[i].x[1] - coord_array[j].x[1];
	return (length_t) ceil(my_hypot(xd,yd));
}

@ I converted over to using the |hypot| function.  But things were running
about 15% slower on an SGI Challenge (150MHz MIPS R4400), 
even using the native C compiler
{\tt cc -xansi}.  The {\tt -xansi} option makes some floating point 
intrinsics inline.  This should be faster, but one should always measure.

So I make the use of |hypot| optional via the |my_hypot| macro.  The
macro definition is changed according to the compile time option
|COST_USE_HYPOT|.

Note that the parameters to this macro should not have side effects.

@<Module definitions@>=
#if defined(COST_USE_HYPOT)
#define my_hypot(A,B) (hypot((A),(B)))
#else
#define my_hypot(A,B) (sqrt((A)*(A)+(B)*(B)))
#endif

@ David Johnson's experiments don't use rounded Euclidean norms.  
If the external variable |noround| is true, then we avoid rounding.

@<Module subroutines@>=
length_t cost_from_euc2d_not_rounded(const int i, const int j);
length_t
cost_from_euc2d_not_rounded(const int i, const int j)
{
	coord_2d *coord_array = p->coord;
	double xd = coord_array[i].x[0] - coord_array[j].x[0];
	double yd = coord_array[i].x[1] - coord_array[j].x[1];
	return (length_t) my_hypot(xd,yd);
}

@
I've had floating point precision problems that I believe are
based on massive cancellation.
So in some experiments I may want to compute the raw distances without
even casting to |length_t|.  This is done by function 
|cost_from_euc2d_raw|.

The declarations of numerical functions
|floor|, |sqrt|, and |hypot| are already included from \file{math.h}.

@<Subroutines@>=
double
cost_from_euc2d_raw(const int i, const int j)
{
	coord_2d *coord_array = p->coord;
	double xd = coord_array[i].x[0] - coord_array[j].x[0];
	double yd = coord_array[i].x[1] - coord_array[j].x[1];
	return my_hypot(xd,yd);
}

@
@<Exported subroutines@>=
double cost_from_euc2d_raw(const int i, const int j);


@ For comparisons between edges, we can strip off the rounding and
square root computations.  This is about three times faster
on an Intel 486 DX2-66.

@<Module subroutines@>=
length_t pseudo_cost_from_euc2d(const int i, const int j);
length_t
pseudo_cost_from_euc2d(const int i, const int j)
{
	coord_2d *coord_array = p->coord;
	double xd = coord_array[i].x[0] - coord_array[j].x[0];
	double yd = coord_array[i].x[1] - coord_array[j].x[1];
	return (length_t)(xd*xd+yd*yd);	/* Worry about rounding? */
}

@ The GEO type is a geographic great circle distance between 
two longitude and latitude pairs.


Henry Baker suggests using verisine and related functions 
in order to keep better precision for arccos near zero.
See his ftp site.  But we keep the standard algorithm as specified
in the TSPLIB paper.

We use the macro |truncate_to_zero| to replace what is written as
|nint| in the original TSPLIB paper.

GCC is of the opinion that strict
ANSI C doesn't define |M_PI| in \file{math.h}.
No matter, at least $\pi$ is a constant.

@d truncate_to_zero(x) ((double)(int)(x))
@d PI (3.14159265358979323846)

@<Module subroutines@>=
length_t cost_from_geo(const int i, const int j);
length_t
cost_from_geo(const int i, const int j)
{
	coord_2d *coord_array = p->coord;
	const double x1 = coord_array[i].x[0], x2 = coord_array[j].x[0];
	const double y1 = coord_array[i].x[1], y2 = coord_array[j].x[1];
    double degrees, minutes;
	double latitude1, latitude2, longitude1, longitude2;
    double q1, q2, q3;
	const double radius=6378.388;

    degrees = truncate_to_zero(x1);
    minutes = x1 - degrees;
    latitude1 = (PI/180) * (degrees + minutes * (5.0/3.0));

    degrees = truncate_to_zero(x2);
    minutes = x2 - degrees;
    latitude2 = (PI/180) * (degrees + minutes * (5.0/3.0));

    degrees = truncate_to_zero (y1);
    minutes = y1 - degrees;
    longitude1 = (PI/180) * (degrees + minutes * (5.0/3.0));

    degrees = truncate_to_zero (y2);
    minutes = y2 - degrees;
    longitude2 = (PI/180) * (degrees + minutes * (5.0/3.0));

    q1 = cos (longitude1 - longitude2);
    q2 = cos (latitude1 - latitude2);
    q3 = cos (latitude1 + latitude2);
    return (length_t) 
		truncate_to_zero(radius * acos(0.5*((1+q1)*q2 - (1-q1) * q3)) + 1);
}


@ Cost function ATT is just a bit funky.  
It is much like a scaled Euclidean metric.

That funky constant is $1/\sqrt{10}$.  (Thanks, \type{bc}.)

@<Module subroutines@>=
length_t cost_from_att(const int i, const int j);
length_t
cost_from_att(const int i, const int j)
{
	coord_2d *coord_array = p->coord;
	double xd = coord_array[i].x[0] - coord_array[j].x[0];
	double yd = coord_array[i].x[1] - coord_array[j].x[1];
	return (length_t) ceil(my_hypot(xd,yd)*0.31622776601683793319988935);
}

@ Cost function |DSJ_RANDOM| generates random 
scaled weights based only on a scale, a seed, and the two indices $i$
and $j$.  

Remember that our vertex numbers are zero-based, so we have to add 1
before generating the salt.

@<Module subroutines@>=

length_t cost_from_dsj_random(const int i, const int j);
length_t
cost_from_dsj_random(const int ii, const int jj)
{
	const int32 i=ii, j=jj;
	const int32 salt1 = 0x12345672*(i+1) + 1;
	const int32 salt2 = 0x12345672*(j+1) + 1;
	int32 x,y,z;

    x = salt1 & salt2;
    y = salt1 | salt2;
    z = dsj_random_param;

    x *= z;
    y *= x;
    z *= y;

    z ^= dsj_random_param;

    x *= z;
    y *= x;
    z *= y;

    x = ((salt1 + salt2) ^ z) &0x7fffffff;
    return (length_t) (x*dsj_random_factor);
}

@ The two parameters are also part of the cost function context.
@<Set the |cost|...@>=
dsj_random_factor = p->dsj_random_factor;
dsj_random_param = p->dsj_random_param;

@ For consistent results, we need a 32 bit integer type.
@<Module definitions@>=
#if SIZEOF_INT==4
typedef int int32;
#elif SIZEOF_SHORT==4
typedef short int int32;
#elif SIZEOF_LONG==4
typedef long int32;
#else
#error "I need a 32 bit integer for consistent results with DSJ_RANDOM"
#endif

@ We choose among the above cost functions based upon the type
of the problem.  In the Euclidean case, we pay attention to the
|noround| variable.

@<Set the |cost| function according to the current context@>=
switch( p->edge_weight_type ) {
case EXPLICIT: 
	cost = cost_from_matrix;
	pseudo_cost = cost_from_matrix; 
	break;
case EUC_2D: 
	{
	extern int noround;	/* Defined by module \module{LK}. */
	cost = noround ? cost_from_euc2d_not_rounded : cost_from_euc2d;
	}
	pseudo_cost = pseudo_cost_from_euc2d; 
	break;
case CEIL_2D: 
	{
	extern int noround;	/* Defined by module \module{LK}. */
	cost = noround ? cost_from_euc2d_not_rounded : cost_from_ceil2d;
	}
	pseudo_cost = pseudo_cost_from_euc2d; 
	break;
case GEO: 
	cost = cost_from_geo;
	pseudo_cost = cost_from_geo; 
	break;
case ATT: 
	cost = cost_from_att;
	pseudo_cost = cost_from_att; 
	break;
case DSJ_RANDOM: 
	cost = cost_from_dsj_random;
	pseudo_cost = cost_from_dsj_random; 
	break;
case RANDOM_EDGES: 
	errorif(p->short_edge_weights==NULL,"RANDOM_EDGES specified but no SEED given");
	cost = cost_from_short_matrix;
	pseudo_cost = cost_from_short_matrix; 
	break;
case NO_EDGE_TYPE:
default:
	errorif(1,"Switching to an instance with unknown edge type %d",
		p->edge_weight_type);
}

@*Forcing even number of vertices.
Some problems require that the number of vertices be even.
For instance, perfect matchings only exist when there are an even number
of vertices.

@<Possibly remove a vertex@>=
if ( force_even_num && (p->input_n % 2) ) {
	@<Remove a vertex@>@;
}

@ There are two cases: geometric and non-geometric.

For a non-geometric instance, we just remove the last vertex.

For a geometric instance, we follow David Applegate and William Cook,
``Solving Large-Scale Matching Problems'', in {\sl Network Flows and
Matching}, First DIMACS Implementation Challenge, David S.~Johnson and
Catherine C.~McGeoch, editors, 1993, pages 557--576.
They remove
the vertex whose coordinates are lexicographically last.
That is, find the vertices with maximum $x$ coordinate.  From
among those, pick one with the maximum $y$ coordinate.  
If there's still a tie, pick the last-occuring one.
(This is a little more spelled-out than what they said: ``we sorted
the $x,y$ coordinates and deleted the last point.'')
@^Applegate, David@>
@^Cook, William@>
@^Johnson, David S.@>
@^McGeoch, Catherine C.@>

In the geometric case we {\it swap\/}
the lexicographic-coordinate last point with the
physically-stored last coordinate so that we can always reconstruct an
output that is 
equivalent to the original input.

@<Remove a vertex@>=
p->n--;
switch ( p->edge_weight_type ) {
case EUC_2D:
case CEIL_2D:
case GEO:
case ATT:
	{ int i, lex_last=0;
	for (i=1;i<p->input_n;i++) {
		if ( p->coord[i].x[0] > p->coord[lex_last].x[0] @|
			|| (p->coord[i].x[0] == p->coord[lex_last].x[0]
			   && p->coord[i].x[1] >= p->coord[lex_last].x[1]) )
			lex_last = i;
	}
	{
	coord_2d t = p->coord[p->n]; /* Now swap them. */
	p->coord[p->n] = p->coord[lex_last];
	p->coord[lex_last] = t;
	}
	}
default: break;  /* We already decremented |p->n|. */
}

@*Checking consistency.
If the arrays are set up right then the cost functions should also be set
correctly.

@<Check consistency@>=
if (p->n) {
	switch(p->edge_weight_type) {
	case EUC_2D:
	case CEIL_2D:
	case GEO:
		errorif(p->edge_weight_format != NO_EDGE_FORMAT,
			"Edge weight format should be NO_EDGE_FORMAT, but is %s",
				edge_weight_format_name[p->edge_weight_format]);
		errorif(p->coord == NULL,"No coordinates were read");
		break;
	case EXPLICIT:
		errorif(p->edge_weight_format==NO_EDGE_FORMAT,
			"Edge weight shouldn't be NO_EDGE_FORMAT, but it is");
		errorif(p->edge_weights == NULL,"No edge weights were read");
		break;
	case DSJ_RANDOM:
	default:
		break;
	}
}

@*Debugging output routines.

%When debugging output is desired, |verbose>0|.

When we're done reading the file, we output some summary statistics
about its contents to a debugging file.  The file handle is |debug|, passed
in to |read_tsp_file| as a parameter.

@ First we output the number of cities and create 1-based arrays
for the |x| and |y| coordinates.

Unfortunately, the maximum array size on some PostScript implementations
is  quite small.  For example, the default in the Ghostscript implementation
is 8191.  If we have too many cities, then we can't create the arrays.
In these cases, we must take care later on to not use any PostScript routines
that require them.

@<Debugging output@>=
if (debug) {
	fprintf(debug,"/N {%d} def        %% number of nodes\n",p->input_n);
	if ( p->input_n < 8191 )
		fprintf(debug,"/xs N 1 add array def\n/ys N 1 add array def\n");
}


@ Then we output the bounding positions.

@<Debugging output@>=
if (debug) {
const double xdiff = ((double) p->xmax) - ((double)p->xmin);
const double ydiff = ((double) p->ymax) - ((double)p->ymin);
const double maxrange = max(xdiff,ydiff);
const double xoffset = xdiff<ydiff ? (maxrange-xdiff)/2 : 0.0;
const double yoffset = ydiff<xdiff ? (maxrange-ydiff)/2 : 0.0;
fprintf(debug,"/xmin {%f} def \n",p->xmin);
fprintf(debug,"/xmax {%f} def \n",p->xmax);
fprintf(debug,"/ymin {%f} def \n",p->ymin);
fprintf(debug,"/ymax {%f} def \n",p->ymax);
fprintf(debug,"/maxrange {%f} def \n", maxrange );
fprintf(debug,"/xoffset  {%f} def \n", xoffset);
fprintf(debug,"/yoffset  {%f} def \n", yoffset);
}

@ And the coordinates themselves.
@<Debugging output@>=
if (debug) {int i;
for (i=0; i<p->input_n ; i++) {
	fprintf(debug,"%f %f ts\n",p->coord[i].x[0],p->coord[i].x[1]);
}
fflush(debug);
}

@*Writing TSPLIB files.
Given a |tsp_instance_t| object, we'd like to write it out again.

We have two routines.  Procedure |write_tsp_file|

@<Subroutines@>=
void
write_tsp_file(tsp_instance_t *tsp,FILE *out)
{
	write_tsp_file_clip(tsp, out, 0);
}

void write_tsp_file_clip(tsp_instance_t *tsp, FILE *out, int force_even_num)
{
int n=tsp->input_n;
if ( (n%2) && force_even_num ) n--;

if(out) {
fprintf(out,"NAME: %s\n",tsp->name);
fprintf(out,"TYPE: TSP\n");
fprintf(out,"COMMENT: %s%s\n",
	(tsp->comment?tsp->comment:""),
	(n<tsp->input_n?"| clip":""));
fprintf(out,"DIMENSION: %d\n",n);
switch(tsp->edge_weight_type) {
case CEIL_2D: fprintf(out,"EDGE_WEIGHT_TYPE: CEIL_2D\n"); 
	@<Write the coordinates@>@;
	break;
case EUC_2D:  fprintf(out,"EDGE_WEIGHT_TYPE: EUC_2D\n"); 
	@<Write the coordinates@>@;
	break;
case GEO:  fprintf(out,"EDGE_WEIGHT_TYPE: GEO\n"); 
	@<Write the coordinates@>@;
	break;
case ATT:  fprintf(out,"EDGE_WEIGHT_TYPE: GEO\n"); 
	@<Write the coordinates@>@;
	break;
case DSJ_RANDOM:  fprintf(out,"EDGE_WEIGHT_TYPE: DSJ_RANDOM\n"); 
	fprintf(out,"SCALE: %f\nSEED: %ld",tsp->scale,tsp->seed);
	break;
case EXPLICIT: fprintf(out,"EDGE_WEIGHT_TYPE: EXPLICIT\n");
	{ int format=tsp->edge_weight_format;
	@<Write the explicit weights in format |format|@>@;
	}
	break;
case RANDOM_EDGES: fprintf(out,"EDGE_WEIGHT_TYPE: EXPLICIT\n");
	{ int format=UPPER_ROW;
	@<Write the explicit weights in format |format|@>@;
	}
	break;
case NO_EDGE_TYPE:
default:
	errorif(1,"No edge type specified by instance: have %d instead",
		tsp->edge_weight_type);
}
fprintf(out,"EOF\n");
}
}

@
@<Exported subroutines@>=
void write_tsp_file(tsp_instance_t *tsp,FILE *out);
void write_tsp_file_clip(tsp_instance_t *tsp,FILE *out, int force_even_num);

@
@<Write the coordinates@>=
fprintf(out,"NODE_COORD_SECTION\n");
{int i;
for (i=0;i<n;i++) {
fprintf(out,"%d %g %g\n",i+1,tsp->coord[i].x[0],tsp->coord[i].x[1]);
}
}


@
@<Write the explicit weights in format |format|@>=
{ int row, col;
	switch (format) {
	case LOWER_DIAG_ROW:
		fprintf(out,"EDGE_WEIGHT_FORMAT: LOWER_DIAG_ROW\n");
		fprintf(out,"EDGE_WEIGHT_SECTION\n");
		for (row=0;row<n;row++) {
			for (col=0;col<=row;col++) {
				fprintf(out," %ld",(long)(tsp->edge_weights[row][col]));
			}
			fprintf(out,"\n");
		}
		break;
	case FULL_MATRIX:
		fprintf(out,"EDGE_WEIGHT_FORMAT: FULL_MATRIX\n");
		fprintf(out,"EDGE_WEIGHT_SECTION:\n");
		for (row=0;row<n;row++) {
			for (col=0;col<n;col++) {
				fprintf(out," %ld",(long)(tsp->edge_weights[row][col]));
			}
			fprintf(out,"\n");
		}
		break;
	case UPPER_ROW:
		fprintf(out,"EDGE_WEIGHT_FORMAT: UPPER_ROW\n");
		fprintf(out,"EDGE_WEIGHT_SECTION:\n");
		for (row=0;row<n;row++) {
			for (col=row+1;col<n;col++) {
				fprintf(out," %ld",(long)(tsp->edge_weights[row][col]));
			}
			fprintf(out,"\n");
		}
		break;
	default: break;
	}
}
	

@*Index.
