
\noindent Copyright \copyright 1994, 1995, 1996, 1997, 1998 David Neto
\smallskip

\noindent 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
\smallskip

\noindent 
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
\smallskip

\noindent   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA  02111-1307, USA.
\smallskip

\noindent   
   You may contact David Neto via email at {\tt netod@@acm.org}, or with
   greater latency at
\smallskip
\noindent{\obeylines
     Department of Computer Science
     University of Toronto
     10 King's College Rd.
     Toronto, Ontario
     M5S 3G4
     Canada
}
\medskip


\noindent\hbox{}\hrule\hbox{}\penalty-1000
\vskip0.5cm\relax


@i webdefs.w

@*Uniform random Euclidean TSP instances.
This program generates uniform random Euclidean TSP instances in the
TSPLIB format (INSERT REFERENCE).    These kinds of instances are used
by Johnson \etal\ (INSERT REFERENCE)
to study the behaviour of TSP heuristics on large inputs.

@
The points are drawn from a square.  Each integer coordinate is drawn 
from a uniform distribution over 0 through 1000000.
We have the option of using specifying rounded distances 
(option \type{--round}), or taking the ceiling of a raw distance
(option \type{--ceil}, the default).  
We use rounded distances (type |EUC_2D|)
when trying to estimate the behaviour over infinite precision instances,
but ordinarily we take the ceiling (type |CEIL_2D|) in order to preserve
the triangle inequality.
(DSJ, personal communication, August 28, 1998.)


We use |gb_flip|, 
the pseudo-random number generator Knuth implemented for the Stanford
GraphBase.  

@d SIZE (1000001)

@c
#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include "fixincludes.h"

int round = 0;

#include "gb_flip.h"
int 
main(int argc, char**argv) 
{
	int i,n;
	long s;
	char *name;
	@<Gather command line arguments@>@;
	printf("NAME: %s\n",name);
	printf("TYPE: TSP\n");
	printf("COMMENT: Generated by unif seed %ld (%s)\n",s,
		(round ? "round": "ceil"));
	printf("DIMENSION: %d\n",n);
	printf("EDGE_WEIGHT_TYPE: %s\n", (round ? "EUC_2D" : "CEIL_2D") );
	printf("NODE_COORD_SECTION\n");
	gb_init_rand(s);
	for (i=0;i<n;i++) {
		int x, y;
		x = gb_unif_rand(SIZE);
		y = gb_unif_rand(SIZE);
		printf("%d %d %d\n",i+1,x,y);
	}
	printf("EOF\n");
	return 0;
}

@
@<Gather command line arguments@>=
{ int base_arg=1;
if ( argc < 4 || argc > 5 ) {
	@<Output usage string@>@;
	exit(1);
}
if ( argc == 5 ) {
	if ( strcmp(argv[1],"--ceil")==0 ) {
		round = 0; 
	} else if ( strcmp(argv[1],"--round")==0 ) {
		round = 1; 
	} else {
		@<Output usage string@>@;
		exit(1);
	}
	base_arg=2;
}
s=atol(argv[base_arg]);
n=atoi(argv[base_arg+1]);
name=argv[base_arg+2];
}

@
@<Output usage string@>=
fprintf(stderr,"Usage: %s [--ceil|--round] <seed> <n> <name>\n",argv[0]); exit(1);

@*Change log.
{\obeylines
$Log$
}

@*Index.
