#define mark_dirty(CITY) (dirty_add(dirty_set,(CITY) ) )  \
 \

#define write_log(a) (change_log[change_log_next++]= a)  \

#define DEPTHS_BOUND (n+20) 
#define swap_bridge(a,b) {int temp= a[0];a[0]= b[0];b[0]= temp;temp= a[1];a[1]= b[1];b[1]= temp;}
#define bridge_less(a,b) (tour_inorder(edge[0][0],edge[0][1],a[0],b[0]) )  \
 \

#define bridge_t(X) (edge[(X-1) >>1][(X-1) &1]) 
#define bridge_move(a,b,c,d) (tour_flip_arb(bridge_t(a) ,bridge_t(b) ,bridge_t(c) ,bridge_t(d) ) )  \

#define mutate(a) (mutation[mutation_next++]= bridge_t(a) )  \

/*4:*/
#line 585 "./jbmr.w"

#include <config.h>
#include "lkconfig.h"
/*5:*/
#line 602 "./jbmr.w"

#include <stdio.h>
#if !defined(__USE_MISC)
#define __USE_MISC  
#endif
#include <stdlib.h>
#include <stddef.h>
#include <limits.h>
#include "fixincludes.h"

/*:5*/
#line 588 "./jbmr.w"

/*8:*/
#line 635 "./jbmr.w"

#include "error.h"
#include "memory.h"
#include "length.h"
#include "read.h"
#include "nn.h"
#include "lk.h"


/*:8*/
#line 589 "./jbmr.w"

/*7:*/
#line 621 "./jbmr.w"

#include "prng.h"
#include "jbmr.h"


/*:7*//*16:*/
#line 706 "./jbmr.w"

#include "dirty.h"

/*:16*//*65:*/
#line 1809 "./jbmr.w"

#include "decluster.h"
#include "declevel.h"

/*:65*//*117:*/
#line 3204 "./jbmr.w"

#include "pool.h"
#include "dict.h"


/*:117*//*127:*/
#line 3362 "./jbmr.w"

#include "tabuhash.h"

/*:127*//*134:*/
#line 3444 "./jbmr.w"

#include "milestone.h"

/*:134*//*142:*/
#line 3514 "./jbmr.w"

#include "resource.h"

/*:142*/
#line 590 "./jbmr.w"


/*30:*/
#line 954 "./jbmr.w"

#if LENGTH_TYPE_IS_EXACT || defined(JBMR_REQUIRE_JOINED_GAIN_VAR)
#define SPLIT_GAIN_VAR 0
#else
#define SPLIT_GAIN_VAR 1
#endif

/*:30*//*55:*/
#line 1568 "./jbmr.w"

#if LENGTH_TYPE_IS_EXACT
#define CAREFUL_OP(LHS,OP,RHS) ((LHS) OP (RHS))
#elif SPLIT_GAIN_VAR
#define CAREFUL_OP(LHS,OP,RHS) ((LHS##_pos) OP ((RHS##_with_slop)+(LHS##_neg)))
#else
#define CAREFUL_OP(LHS,OP,RHS) ((LHS) OP (RHS##_with_slop))
#endif




/*:55*//*169:*/
#line 3874 "./jbmr.w"

#if JBMR_MAX_VERBOSE||JBMR_REPORT_DEPTHS
#define TRACK_DEPTHS 1
#else
#define TRACK_DEPTHS 0
#endif

/*:169*/
#line 592 "./jbmr.w"

/*46:*/
#line 1424 "./jbmr.w"

typedef struct{
length_t gain_for_comparison;
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
length_t cluster_dist;
#endif
#if !SPLIT_GAIN_VAR
length_t gain;
#else 
length_t gain_pos,gain_neg;
#endif 
int t2ip1,t2ip2,scheme_id;
}eligible_t;

/*:46*/
#line 593 "./jbmr.w"

/*11:*/
#line 660 "./jbmr.w"

static int n;

/*:11*//*40:*/
#line 1174 "./jbmr.w"

static int scheme[14][16]= {
{
1,2,5,6,
4,3,2,5},


{
1,2,6,5,
2,6,4,3,
1,5,4,6},


{
5,6,3,4,
1,2,6,3,
6,2,8,7,
1,3,2,8},


{
5,6,3,4,
8,7,6,3,
1,2,3,8},


{
1,2,3,4},


{
1,2,3,4,
1,4,6,5,
6,4,8,7,
1,5,4,8},


{
1,2,3,4,
6,5,8,7,
1,4,5,8},


{
1,2,3,4,
1,4,5,6},


{
1,2,5,6,
5,2,3,4},


{
6,5,8,7,
4,3,8,5,
1,2,3,8},


{
1,2,8,7,
1,7,6,5,
1,5,2,8,
4,3,2,5},


{
6,5,4,3,
6,3,8,7,
1,2,3,8},


{
6,5,8,7,
1,2,5,8,
5,2,3,4},


{-1}
};

static int scheme_max[14]= {8,12,16,12,4,16,12,8,8,12,16,12,12,0};
static int scheme_num_cities[14]= {6,6,8,8,4,8,8,6,6,8,8,8,8,0};

/*:40*//*89:*/
#line 2671 "./jbmr.w"

static int scheme_feas_check[14][10]= {
{-1},
{-1},
{1,3,3,6,2,6,1,8,2,8},
{3,8,1,8,3,6},
{-1},
{1,4,4,6,1,5,4,8},
{1,4,5,8,1,8},
{-1},
{-1},
{1,8,3,8,5,8},
{1,7,1,5,2,8,2,5,1,8},
{1,8,3,6,3,8},
{5,8,2,5,1,8},
{-1}
};

static int scheme_feas_n[14]= {0,0,10,6,0,8,6,0,0,6,10,6,6,0};

/*:89*//*144:*/
#line 3537 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 100 && defined(JBMR_WATCH_THIS_CITY)
static int old_verbose,old_verbose_is_set= 0;
#endif


/*:144*//*182:*/
#line 3975 "./jbmr.w"

#if TRACK_DEPTHS
static int*p_depths= NULL,*m_depths= NULL;
#endif

/*:182*/
#line 594 "./jbmr.w"

/*27:*/
#line 861 "./jbmr.w"

static int tour_inorder(int a,int b,int c,int d);
static int
tour_inorder(int a,int b,int c,int d){
if(tour_next(a)==b)return tour_between(b,c,d);
else if(tour_prev(a)==b)return tour_between(d,c,b);
else{
/*168:*/
#line 3858 "./jbmr.w"

{int i,c,cn;
printf("Tour: 0");
for(i= 0,c= 0;i<n;i++){
errorif(c==0&&i>0,"Not a tour");
cn= tour_next(c);
printf(" %d",cn);
c= cn;
if(i%20==19)printf("\n");
}
printf("\n");
fflush(stdout);
errorif(c!=0,"Not a tour");
}

/*:168*/
#line 868 "./jbmr.w"

errorif(1,"Bad tour_inorder(%d,%d,%d,%d)\n");
return-1;
}
}

/*:27*//*69:*/
#line 1913 "./jbmr.w"

static int
cmp_eligible(const void*a,const void*b)
{
length_t diff= ((const eligible_t*)a)->gain_for_comparison
-((const eligible_t*)b)->gain_for_comparison;
return diff>0?-1:(diff<0?1:

#if defined(QSORT_DETERMINATE)
(int)(((eligible_t*)a)-((eligible_t*)b))
#else
0
#endif
);
}

/*:69*//*85:*/
#line 2463 "./jbmr.w"

static void tour_flip_arb(int a,int b,int c,int d);
static void
tour_flip_arb(int a,int b,int c,int d){
/*152:*/
#line 3628 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("tour_flip_arb(%d,%d,%d,%d)",a,b,c,d);
fflush(stdout);
}
#endif

/*:152*/
#line 2467 "./jbmr.w"

if(b==d||a==c)return;
if(a==tour_next(b)&&d==tour_next(c)){
tour_flip(a,b,c,d);
/*154:*/
#line 3646 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf(" case a\n");
fflush(stdout);
}
#endif

/*:154*/
#line 2471 "./jbmr.w"

}else if(a==tour_prev(b)&&d==tour_prev(c)){
tour_flip(b,a,d,c);
/*155:*/
#line 3655 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf(" case b\n");
fflush(stdout);
}
#endif

/*:155*/
#line 2474 "./jbmr.w"

}else{
printf("\nNeighbour conditions not met\n");
/*168:*/
#line 3858 "./jbmr.w"

{int i,c,cn;
printf("Tour: 0");
for(i= 0,c= 0;i<n;i++){
errorif(c==0&&i>0,"Not a tour");
cn= tour_next(c);
printf(" %d",cn);
c= cn;
if(i%20==19)printf("\n");
}
printf("\n");
fflush(stdout);
errorif(c!=0,"Not a tour");
}

/*:168*/
#line 2477 "./jbmr.w"

printf("\t(%d) %d (%d)",tour_prev(a),a,tour_next(a));
printf("\t(%d) %d (%d)",tour_prev(b),b,tour_next(b));
printf("\t(%d) %d (%d)",tour_prev(c),c,tour_next(c));
printf("\t(%d) %d (%d)",tour_prev(d),d,tour_next(d));
printf("\n");
errorif(1,"Neighbour conditions not met.");
}
}

/*:85*//*118:*/
#line 3220 "./jbmr.w"

#if defined(TABU_SPLAY)
static int cmp_pair(const void*a,const void*b);
static int
cmp_pair(const void*a,const void*b){
int a1= *((const int*)a),a2= *(((const int*)a)+1);
int b1= *((const int*)b),b2= *(((const int*)b)+1);
if(a1<a2){int t= a1;a1= a2;a2= t;}
if(b1<b2){int t= b1;b1= b2;b2= t;}
return a1==b1?a2-b2:a1-b1;
}
#endif


/*:118*//*124:*/
#line 3325 "./jbmr.w"

#if defined(TABU_SPLAY)
static void move_t(void*env,void**p);
static void
move_t(void*env,void**p){
int*old_t= ((int**)env)[0],*t= ((int**)env)[1];
*p= (void*)(t+((int*)(*p)-old_t));
}
#endif


/*:124*//*157:*/
#line 3682 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
#if !SPLIT_GAIN_VAR
#define put_city(X) \
if ( verbose >= 300 ) { \
 int i;\
 length_t cg =  cum_gain, bg =  best_gain; \
 for ( i= 0;i<(X);i++) {printf(" ");}\
 printf("t%d == %d p=%d n=%d",(X),t[(X)],tour_prev(t[(X)]),tour_next(t[(X)]));\
 if (X>1) { \
  int c =  cost(t[(X)-1],t[X]); \
  printf(" c(t%d,t%d)=%d",(X)-1,(X),c); \
  c =  cost(t[(X)],t[1]); \
  printf(" c(t%d,t1)=%d",(X),c); \
 } \
 printf("\tcg "length_t_spec" bg "length_t_spec"\n",length_t_pcast(cg),\
  length_t_pcast(bg)); \
 fflush(stdout); \
}
#else
#define put_city(X) \
if ( verbose >= 300 ) { \
 int i;\
 length_t cg =  cum_gain_pos-cum_gain_neg, bg =  best_gain; \
 for ( i= 0;i<(X);i++) {printf(" ");}\
 printf("t%d == %d p=%d n=%d",(X),t[(X)],tour_prev(t[(X)]),tour_next(t[(X)]));\
 if (X>1) { \
  int c =  cost(t[(X)-1],t[X]); \
  printf(" c(t%d,t%d)=%d",(X)-1,(X),c); \
  c =  cost(t[(X)],t[1]); \
  printf(" c(t%d,t1)=%d",(X),c); \
 } \
 printf("\tcg "length_t_spec" bg "length_t_spec"\n",length_t_pcast(cg),\
  length_t_pcast(bg)); \
 fflush(stdout); \
}

#endif
#else
#define put_city(X)
#endif

/*:157*/
#line 595 "./jbmr.w"

/*9:*/
#line 648 "./jbmr.w"

void
jbmr_setup(int the_n){
n= the_n;
/*180:*/
#line 3960 "./jbmr.w"

#if TRACK_DEPTHS && defined(TABU_JBMR)
p_depths= new_arr_of_zero(int,DEPTHS_BOUND);
m_depths= new_arr_of_zero(int,DEPTHS_BOUND);
#endif


/*:180*/
#line 652 "./jbmr.w"

}

/*:9*//*12:*/
#line 664 "./jbmr.w"

void
jbmr_cleanup(void)
{
n= 0;
/*181:*/
#line 3968 "./jbmr.w"

#if TRACK_DEPTHS
free_mem(p_depths);mem_deduct(DEPTHS_BOUND*sizeof(int));
free_mem(m_depths);mem_deduct(DEPTHS_BOUND*sizeof(int));
#endif

/*:181*/
#line 669 "./jbmr.w"

}

/*:12*//*21:*/
#line 761 "./jbmr.w"

void
jbmr_run(const int iterations,prng_t*random_stream)
{
/*15:*/
#line 702 "./jbmr.w"

dirty_set_t*dirty_set;

/*:15*//*23:*/
#line 813 "./jbmr.w"

int*t,t_max_alloc;

/*:23*//*31:*/
#line 962 "./jbmr.w"

#if SPLIT_GAIN_VAR
length_t cum_gain_pos,cum_gain_neg;
#endif

/*:31*//*32:*/
#line 971 "./jbmr.w"

length_t best_gain;

/*:32*//*33:*/
#line 983 "./jbmr.w"

#if !SPLIT_GAIN_VAR
length_t cum_gain;
#endif

/*:33*//*34:*/
#line 1010 "./jbmr.w"

int best_two_i,best_exit_a,best_exit_b,best_scheme_id;


/*:34*//*35:*/
#line 1043 "./jbmr.w"

int more_backtracking;

/*:35*//*36:*/
#line 1058 "./jbmr.w"

int two_i;

/*:36*//*41:*/
#line 1277 "./jbmr.w"

int scheme_id,base_scheme[9];


/*:41*//*47:*/
#line 1447 "./jbmr.w"

eligible_t*(e[4]);

/*:47*//*50:*/
#line 1474 "./jbmr.w"

int en[4];

/*:50*//*51:*/
#line 1484 "./jbmr.w"

int ec[4];


/*:51*//*52:*/
#line 1517 "./jbmr.w"

#if !(LENGTH_TYPE_IS_EXACT)
length_t instance_epsilon= incumbent_len*LENGTH_MACHINE_EPSILON;
length_t best_gain_with_slop;
#endif

/*:52*//*57:*/
#line 1668 "./jbmr.w"

int num_reject_by_cum_1,num_reject_pre_e_build;
const int no_extra_backtrack= !extra_backtrack;

/*:57*//*61:*/
#line 1731 "./jbmr.w"

#if !defined(JBMR_UNROLL_PREV_NEXT_LOOP)
int(*tour_neighbour[2])(int);
#endif

/*:61*//*78:*/
#line 2095 "./jbmr.w"

int*change_log= NULL,change_log_max_alloc,change_log_next= 0;


/*:78*//*95:*/
#line 2845 "./jbmr.w"

int last_special_two_i;
int generic_flips_made;

/*:95*//*115:*/
#line 3190 "./jbmr.w"

#if defined(TABU_SPLAY)
dict_t*tabu= dict_create(cmp_pair,NULL);
#endif

/*:115*//*126:*/
#line 3351 "./jbmr.w"

#if defined(TABU_HASH)
tabu_hash_t*tabu_hash= NULL;
tabu_hash_t*(*tabu_hash_create)(int vertex_bound,int max_size)= NULL;
void(*tabu_hash_destroy)(tabu_hash_t*th)= NULL;
int(*tabu_hash_includes)(tabu_hash_t*th,int u,int v)= NULL;
void(*tabu_hash_add)(tabu_hash_t*th,int u,int v)= NULL;
void(*tabu_hash_make_empty)(tabu_hash_t*th)= NULL;
#endif

/*:126*//*135:*/
#line 3450 "./jbmr.w"

milestone_state_t ms_lower_bound;
milestone_state_t ms_upper_bound;

/*:135*//*161:*/
#line 3777 "./jbmr.w"

int num_reject_by_decluster;


/*:161*//*177:*/
#line 3930 "./jbmr.w"

#if TRACK_DEPTHS
int probe_depth,move_depth;
#endif

/*:177*//*179:*/
#line 3953 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
int probes= 0;
#endif

/*:179*//*186:*/
#line 4019 "./jbmr.w"

#if TRACK_DEPTHS
int last_probe_depth= 0;
#endif


/*:186*//*189:*/
#line 4059 "./jbmr.w"

length_t previous_incumbent_len= 0;

/*:189*//*199:*/
#line 4240 "./jbmr.w"

int mutation[12];

/*:199*/
#line 765 "./jbmr.w"

int iteration;

/*58:*/
#line 1673 "./jbmr.w"

num_reject_by_cum_1= num_reject_pre_e_build= 0;


/*:58*//*62:*/
#line 1737 "./jbmr.w"

#if !defined(JBMR_UNROLL_PREV_NEXT_LOOP)
tour_neighbour[0]= tour_prev;
tour_neighbour[1]= tour_next;
#endif

/*:62*//*128:*/
#line 3383 "./jbmr.w"

#if defined(TABU_HASH)
{const int max_tabu_size
= max_generic_flips<(INT_MAX-4)?max_generic_flips+4:n;
if(max_tabu_size<=n){
tabu_hash_create= tabu_hash_bd_create;
tabu_hash_destroy= tabu_hash_bd_destroy;
tabu_hash_includes= tabu_hash_bd_includes;
tabu_hash_add= tabu_hash_bd_add;
tabu_hash_make_empty= tabu_hash_bd_make_empty;
}else{
tabu_hash_create= tabu_hash_unbd_create;
tabu_hash_destroy= tabu_hash_unbd_destroy;
tabu_hash_includes= tabu_hash_unbd_includes;
tabu_hash_add= tabu_hash_unbd_add;
tabu_hash_make_empty= tabu_hash_unbd_make_empty;
}
tabu_hash= tabu_hash_create(n,max_tabu_size);
}
#endif

/*:128*//*136:*/
#line 3455 "./jbmr.w"

milestone_initialize(&ms_lower_bound,lower_bound_name,(length_t)lower_bound_value,
begin_data_structures_mark);
milestone_initialize(&ms_upper_bound,upper_bound_name,(length_t)upper_bound_value,
begin_data_structures_mark);
milestone_show_initial(&ms_lower_bound,incumbent_len);
milestone_show_initial(&ms_upper_bound,incumbent_len);

/*:136*//*162:*/
#line 3782 "./jbmr.w"

num_reject_by_decluster= 0;

/*:162*/
#line 768 "./jbmr.w"

/*24:*/
#line 824 "./jbmr.w"

t_max_alloc= 128;
t= new_arr_of(int,t_max_alloc);

/*:24*//*48:*/
#line 1454 "./jbmr.w"

e[0]= new_arr_of(eligible_t,nn_max_bound*2);
e[1]= new_arr_of(eligible_t,nn_max_bound*2);
e[2]= new_arr_of(eligible_t,nn_max_bound*2);
e[3]= new_arr_of(eligible_t,nn_max_bound*2);

/*:48*//*76:*/
#line 2083 "./jbmr.w"

change_log_max_alloc= 10000;
change_log= new_arr_of(int,change_log_max_alloc);

/*:76*/
#line 769 "./jbmr.w"

/*18:*/
#line 720 "./jbmr.w"

dirty_set= dirty_create(n,1,prng_unif_int(random_stream,n));

/*:18*/
#line 770 "./jbmr.w"


for(iteration= 0;iteration<iterations;iteration++){
int dirty;
/*96:*/
#line 2850 "./jbmr.w"

last_special_two_i= INT_MAX;
generic_flips_made= 0;




/*:96*/
#line 774 "./jbmr.w"

while((dirty= dirty_remove(dirty_set))>=0){
/*42:*/
#line 1290 "./jbmr.w"

{
int t1_n[2],t1_i;
length_t t1_l[2];
/*143:*/
#line 3518 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 100
if(verbose>=100){
printf("Search for an improvement starting at city %d\n",dirty);
fflush(stdout);
#if defined(JBMR_WATCH_THIS_CITY)
if(dirty==JBMR_WATCH_THIS_CITY){
old_verbose= verbose;
old_verbose_is_set= 1;
verbose= 2000;
}else if(old_verbose_is_set){
verbose= old_verbose;
old_verbose_is_set= 0;
}
#endif
}
#endif

/*:143*/
#line 1294 "./jbmr.w"

t[1]= dirty;
t1_n[0]= tour_prev(t[1]);
t1_n[1]= tour_next(t[1]);
t1_l[0]= cost(t1_n[0],t[1]);
t1_l[1]= cost(t1_n[1],t[1]);
#if JBMR_FARTHER_T1_FIRST
if(t1_l[0]<t1_l[1]){
int tmp;
length_t tmp_l;
tmp= t1_n[0];t1_n[0]= t1_n[1];t1_n[1]= tmp;
tmp_l= t1_l[0];t1_l[0]= t1_l[1];t1_l[1]= tmp_l;
}
#endif

/*43:*/
#line 1335 "./jbmr.w"

#if !SPLIT_GAIN_VAR
cum_gain= 0;
#else
cum_gain_pos= cum_gain_neg= 0;
#endif
best_gain= 0;best_two_i= 0;best_exit_a= best_exit_b= -1;
more_backtracking= 1;scheme_id= best_scheme_id= -1;

/*:43*//*53:*/
#line 1526 "./jbmr.w"

#if !(LENGTH_TYPE_IS_EXACT)
best_gain_with_slop= instance_epsilon;
#endif



/*:53*//*176:*/
#line 3924 "./jbmr.w"

#if TRACK_DEPTHS
probe_depth= move_depth= 0;
#endif

/*:176*/
#line 1309 "./jbmr.w"

put_city(1);
for(t1_i= 0;t1_i<2&&more_backtracking;t1_i++){
t[2]= t1_n[t1_i];
/*185:*/
#line 4005 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 70
if(verbose>=70){
printf("(t1,t2)= (%d,%d) cost=%f, d=%f p=%d\n",t[1],t[2],(double)cost(t[1],t[2]),
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
(double)decluster_d(t[1],t[2])
#else
(double)-1
#endif
,last_probe_depth);
}
#endif

/*:185*/
#line 1313 "./jbmr.w"

#if !SPLIT_GAIN_VAR
cum_gain= t1_l[t1_i];
#else
cum_gain_pos= t1_l[t1_i];
cum_gain_neg= 0;
#endif
put_city(2);
/*45:*/
#line 1389 "./jbmr.w"

two_i= 2;
/*175:*/
#line 3917 "./jbmr.w"

#if TRACK_DEPTHS
if(probe_depth<two_i+2)(probe_depth= two_i+2);
#endif


/*:175*/
#line 1391 "./jbmr.w"

#define BL 0
{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
const length_t cluster_dist= decluster_d(t[1],t[2]);
#else
const length_t cluster_dist= 0;
#endif
/*56:*/
#line 1623 "./jbmr.w"

en[BL]= ec[BL]= 0;
if(CAREFUL_OP(cum_gain,>,cluster_dist+best_gain)){
int i,t2ip1,t2ip2,enbl,*neighbour_list,nn_bound;
#if SPLIT_GAIN_VAR
length_t cum_1_pos,cum_1_neg,cum_2_pos,cum_2_neg;
#else
length_t cum_1,cum_2;
#endif
/*156:*/
#line 3664 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 400
if(verbose>=400){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3667 "./jbmr.w"

printf("%d %d "length_t_spec" "length_t_spec" s%d\n",t[two_i-1],t[two_i],
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_gain),
#else
length_t_pcast(cum_gain_pos-cum_gain_neg),
#endif
length_t_pcast(best_gain),scheme_id);
fflush(stdout);
}
#endif



/*:156*/
#line 1632 "./jbmr.w"



#if SPLIT_GAIN_VAR
cum_1_pos= cum_gain_pos;
#endif

neighbour_list= nn_list(t[two_i],&nn_bound);
for(i= 0,enbl= 0;i<nn_bound;i++){
t2ip1= neighbour_list[i];
#if SPLIT_GAIN_VAR
cum_1_neg= cum_gain_neg+cost(t[two_i],t2ip1);
#else
cum_1= cum_gain-cost(t[two_i],t2ip1);
#endif

if(CAREFUL_OP(cum_1,<=,best_gain)){
/*163:*/
#line 3786 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3789 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("Terminating |cum_1| "length_t_spec"\n",length_t_pcast(cum_1));
#else
printf("Terminating |cum_1| "length_t_spec" "
"(== "length_t_spec" - "length_t_spec")\n",
length_t_pcast(cum_1_pos-cum_1_neg),
length_t_pcast(cum_1_pos),
length_t_pcast(cum_1_neg));
#endif
fflush(stdout);
}
#endif

/*:163*/
#line 1649 "./jbmr.w"

num_reject_by_cum_1++;
break;
}

/*59:*/
#line 1683 "./jbmr.w"

#if BL==0
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 1685 "./jbmr.w"

#endif

/*:59*//*79:*/
#line 2131 "./jbmr.w"

#if BL==1
if(t2ip1!=t[3]){
switch(e[0][ec[0]].scheme_id){
case 0:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[3])?0:2;break;
case 4:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[4])?5:8;break;
default:errorif(1,"Non exhaustive switch: %d",e[0][ec[0]].scheme_id);
}
/*165:*/
#line 3833 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3836 "./jbmr.w"
printf("base_scheme5 == %d\n",base_scheme[5]);
fflush(stdout);
}
#endif

/*:165*/
#line 2139 "./jbmr.w"

/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2140 "./jbmr.w"

}
#endif


/*:79*//*86:*/
#line 2507 "./jbmr.w"

#if BL==2
if(t2ip1!=t[5]){
int i1,i2,i4;
switch(base_scheme[7]= e[1][ec[1]].scheme_id){
case 2:i1= 1;i2= 2;i4= 3;break;
case 5:i1= 6,i2= 5,i4= 4;break;
case 9:i1= 1,i2= 2,i4= 5;break;
default:errorif(1,"Got to 4-change in base scheme %d",base_scheme[7]);
i1= i2= i4= -1;
break;
}
if(tour_inorder(t[i1],t[i2],t2ip1,t[i4])){
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2520 "./jbmr.w"

}
}
#endif


/*:86*//*97:*/
#line 2860 "./jbmr.w"

#if BL==3
if(t[two_i]==tour_prev(t[1]))t2ip2= tour_next(t2ip1);
else t2ip2= tour_prev(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 2864 "./jbmr.w"

#endif


/*:97*/
#line 1654 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
en[BL]= enbl;
}else{
num_reject_pre_e_build++;
}

/*:56*/
#line 1399 "./jbmr.w"

}
/*68:*/
#line 1897 "./jbmr.w"

sort(e[BL],(size_t)en[BL],sizeof(eligible_t),cmp_eligible);

/*:68*/
#line 1401 "./jbmr.w"

#undef BL
/*71:*/
#line 1980 "./jbmr.w"

for(ec[0]= 0;more_backtracking&&ec[0]<en[0];ec[0]++){
eligible_t*this_move= &e[0][ec[0]];
t[3]= this_move->t2ip1;
t[4]= this_move->t2ip2;
#if !SPLIT_GAIN_VAR
cum_gain= this_move->gain;
#else
cum_gain_pos= this_move->gain_pos;
cum_gain_neg= this_move->gain_neg;
#endif
two_i= 4;
/*175:*/
#line 3917 "./jbmr.w"

#if TRACK_DEPTHS
if(probe_depth<two_i+2)(probe_depth= two_i+2);
#endif


/*:175*/
#line 1992 "./jbmr.w"

#define BL 1
{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
const length_t cluster_dist= this_move->cluster_dist;
#else
const length_t cluster_dist= 0;
#endif
/*56:*/
#line 1623 "./jbmr.w"

en[BL]= ec[BL]= 0;
if(CAREFUL_OP(cum_gain,>,cluster_dist+best_gain)){
int i,t2ip1,t2ip2,enbl,*neighbour_list,nn_bound;
#if SPLIT_GAIN_VAR
length_t cum_1_pos,cum_1_neg,cum_2_pos,cum_2_neg;
#else
length_t cum_1,cum_2;
#endif
/*156:*/
#line 3664 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 400
if(verbose>=400){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3667 "./jbmr.w"

printf("%d %d "length_t_spec" "length_t_spec" s%d\n",t[two_i-1],t[two_i],
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_gain),
#else
length_t_pcast(cum_gain_pos-cum_gain_neg),
#endif
length_t_pcast(best_gain),scheme_id);
fflush(stdout);
}
#endif



/*:156*/
#line 1632 "./jbmr.w"



#if SPLIT_GAIN_VAR
cum_1_pos= cum_gain_pos;
#endif

neighbour_list= nn_list(t[two_i],&nn_bound);
for(i= 0,enbl= 0;i<nn_bound;i++){
t2ip1= neighbour_list[i];
#if SPLIT_GAIN_VAR
cum_1_neg= cum_gain_neg+cost(t[two_i],t2ip1);
#else
cum_1= cum_gain-cost(t[two_i],t2ip1);
#endif

if(CAREFUL_OP(cum_1,<=,best_gain)){
/*163:*/
#line 3786 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3789 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("Terminating |cum_1| "length_t_spec"\n",length_t_pcast(cum_1));
#else
printf("Terminating |cum_1| "length_t_spec" "
"(== "length_t_spec" - "length_t_spec")\n",
length_t_pcast(cum_1_pos-cum_1_neg),
length_t_pcast(cum_1_pos),
length_t_pcast(cum_1_neg));
#endif
fflush(stdout);
}
#endif

/*:163*/
#line 1649 "./jbmr.w"

num_reject_by_cum_1++;
break;
}

/*59:*/
#line 1683 "./jbmr.w"

#if BL==0
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 1685 "./jbmr.w"

#endif

/*:59*//*79:*/
#line 2131 "./jbmr.w"

#if BL==1
if(t2ip1!=t[3]){
switch(e[0][ec[0]].scheme_id){
case 0:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[3])?0:2;break;
case 4:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[4])?5:8;break;
default:errorif(1,"Non exhaustive switch: %d",e[0][ec[0]].scheme_id);
}
/*165:*/
#line 3833 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3836 "./jbmr.w"
printf("base_scheme5 == %d\n",base_scheme[5]);
fflush(stdout);
}
#endif

/*:165*/
#line 2139 "./jbmr.w"

/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2140 "./jbmr.w"

}
#endif


/*:79*//*86:*/
#line 2507 "./jbmr.w"

#if BL==2
if(t2ip1!=t[5]){
int i1,i2,i4;
switch(base_scheme[7]= e[1][ec[1]].scheme_id){
case 2:i1= 1;i2= 2;i4= 3;break;
case 5:i1= 6,i2= 5,i4= 4;break;
case 9:i1= 1,i2= 2,i4= 5;break;
default:errorif(1,"Got to 4-change in base scheme %d",base_scheme[7]);
i1= i2= i4= -1;
break;
}
if(tour_inorder(t[i1],t[i2],t2ip1,t[i4])){
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2520 "./jbmr.w"

}
}
#endif


/*:86*//*97:*/
#line 2860 "./jbmr.w"

#if BL==3
if(t[two_i]==tour_prev(t[1]))t2ip2= tour_next(t2ip1);
else t2ip2= tour_prev(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 2864 "./jbmr.w"

#endif


/*:97*/
#line 1654 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
en[BL]= enbl;
}else{
num_reject_pre_e_build++;
}

/*:56*/
#line 2000 "./jbmr.w"

}
/*68:*/
#line 1897 "./jbmr.w"

sort(e[BL],(size_t)en[BL],sizeof(eligible_t),cmp_eligible);

/*:68*/
#line 2002 "./jbmr.w"

#undef BL
/*82:*/
#line 2371 "./jbmr.w"

for(ec[1]= 0;more_backtracking&&ec[1]<en[1];ec[1]++){
eligible_t*this_move= &e[1][ec[1]];
t[5]= this_move->t2ip1;
t[6]= this_move->t2ip2;
#if !SPLIT_GAIN_VAR
cum_gain= this_move->gain;
#else
cum_gain_pos= this_move->gain_pos;
cum_gain_neg= this_move->gain_neg;
#endif
two_i= 6;
/*175:*/
#line 3917 "./jbmr.w"

#if TRACK_DEPTHS
if(probe_depth<two_i+2)(probe_depth= two_i+2);
#endif


/*:175*/
#line 2383 "./jbmr.w"

if(scheme_num_cities[this_move->scheme_id]==6){
scheme_id= this_move->scheme_id;
/*84:*/
#line 2448 "./jbmr.w"

{int i,n= scheme_max[scheme_id],*s= &scheme[scheme_id][0];
/*149:*/
#line 3584 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Implement scheme %d\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3588 "./jbmr.w"

fflush(stdout);
}
#endif

/*:149*/
#line 2450 "./jbmr.w"

for(i= 0;i<n;i+= 4){
tour_flip_arb(t[s[i]],t[s[i+1]],t[s[i+2]],t[s[i+3]]);
}
}

/*:84*/
#line 2386 "./jbmr.w"

/*93:*/
#line 2775 "./jbmr.w"

{int go_deeper;
last_special_two_i= two_i;
generic_flips_made= 0;
/*111:*/
#line 3161 "./jbmr.w"


/*:111*//*120:*/
#line 3256 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{
int i;
for(i= 2;i<two_i;i+= 2)dict_insert(tabu,t+i);
}
#endif

/*:120*//*130:*/
#line 3413 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{
int i;
for(i= 2;i<two_i;i+= 2)tabu_hash_add(tabu_hash,t[i],t[i+1]);
}
#endif

/*:130*/
#line 2779 "./jbmr.w"

/*147:*/
#line 3563 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 175
if(verbose>=175){
printf("Start generic search\n");
fflush(stdout);
}
#endif


/*:147*/
#line 2780 "./jbmr.w"

for(go_deeper= 1;go_deeper;){
/*94:*/
#line 2809 "./jbmr.w"

#if defined(JBMR_LIMIT_PROBE_DEPTH)
if(generic_flips_made>=max_generic_flips){
/*187:*/
#line 4026 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 75
if(verbose>=75){
printf(" hit max generic flips: %d >= %d\n",
generic_flips_made,max_generic_flips);
}
#endif

/*:187*/
#line 2812 "./jbmr.w"

/*102:*/
#line 2990 "./jbmr.w"

if(best_gain==0){
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2992 "./jbmr.w"

}else if(best_scheme_id==13){
/*103:*/
#line 3001 "./jbmr.w"

{
int low_j,best_is_prefix;
errorif(best_gain<=0,"Bad best_scheme_id == 13");
best_is_prefix= t[best_two_i+1]==best_exit_a
&&t[best_two_i+2]==best_exit_b;
low_j= best_two_i+(best_is_prefix?2:0);
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3008 "./jbmr.w"

if(!best_is_prefix){
tour_flip_arb(t[1],t[best_two_i],best_exit_a,best_exit_b);
}
/*73:*/
#line 2028 "./jbmr.w"

{int i;
for(i= 1;i<=best_two_i;i++){
mark_dirty(t[i]);
}
mark_dirty(best_exit_a);
mark_dirty(best_exit_b);
}

/*:73*//*74:*/
#line 2056 "./jbmr.w"

if(iteration>0){
const int more_log= 4+best_two_i;
/*75:*/
#line 2073 "./jbmr.w"

if(more_log>=change_log_max_alloc){
do{
change_log_max_alloc*= 2;
}while(more_log>=change_log_max_alloc);
change_log= (int*)mem_realloc(change_log,sizeof(int)*change_log_max_alloc);
}

/*:75*/
#line 2059 "./jbmr.w"

{int j;
for(j= 1;j<=best_two_i;j++){
write_log(t[j]);
}
}
write_log(best_exit_a);
write_log(best_exit_b);
write_log(scheme_id);
write_log(3+best_two_i);
}


/*:74*/
#line 3012 "./jbmr.w"

/*173:*/
#line 3903 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= best_two_i+2;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3906 "./jbmr.w"

#endif

/*:173*/
#line 3013 "./jbmr.w"

more_backtracking= 0;
}

/*:103*/
#line 2994 "./jbmr.w"

}

/*:102*/
#line 2813 "./jbmr.w"

go_deeper= 0;
break;
}
#endif

/*:94*/
#line 2782 "./jbmr.w"

/*175:*/
#line 3917 "./jbmr.w"

#if TRACK_DEPTHS
if(probe_depth<two_i+2)(probe_depth= two_i+2);
#endif


/*:175*/
#line 2783 "./jbmr.w"

/*26:*/
#line 842 "./jbmr.w"

if(two_i+3>=t_max_alloc){
#if defined(TABU_SPLAY)
int*old_t= t;
#endif
do{
t_max_alloc*= 2;
}while(two_i+3>=t_max_alloc);
t= (int*)mem_realloc(t,sizeof(int)*t_max_alloc);
/*123:*/
#line 3311 "./jbmr.w"

#if defined(TABU_SPLAY)
{int*env[2];
env[0]= old_t;
env[1]= t;
dict_update_all(tabu,move_t,env);
}
#endif

/*:123*/
#line 851 "./jbmr.w"

}


/*:26*/
#line 2784 "./jbmr.w"

#define BL 3
{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
const length_t cluster_dist= decluster_d(t[1],t[two_i]);
#else
const length_t cluster_dist= 0;
#endif
/*56:*/
#line 1623 "./jbmr.w"

en[BL]= ec[BL]= 0;
if(CAREFUL_OP(cum_gain,>,cluster_dist+best_gain)){
int i,t2ip1,t2ip2,enbl,*neighbour_list,nn_bound;
#if SPLIT_GAIN_VAR
length_t cum_1_pos,cum_1_neg,cum_2_pos,cum_2_neg;
#else
length_t cum_1,cum_2;
#endif
/*156:*/
#line 3664 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 400
if(verbose>=400){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3667 "./jbmr.w"

printf("%d %d "length_t_spec" "length_t_spec" s%d\n",t[two_i-1],t[two_i],
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_gain),
#else
length_t_pcast(cum_gain_pos-cum_gain_neg),
#endif
length_t_pcast(best_gain),scheme_id);
fflush(stdout);
}
#endif



/*:156*/
#line 1632 "./jbmr.w"



#if SPLIT_GAIN_VAR
cum_1_pos= cum_gain_pos;
#endif

neighbour_list= nn_list(t[two_i],&nn_bound);
for(i= 0,enbl= 0;i<nn_bound;i++){
t2ip1= neighbour_list[i];
#if SPLIT_GAIN_VAR
cum_1_neg= cum_gain_neg+cost(t[two_i],t2ip1);
#else
cum_1= cum_gain-cost(t[two_i],t2ip1);
#endif

if(CAREFUL_OP(cum_1,<=,best_gain)){
/*163:*/
#line 3786 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3789 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("Terminating |cum_1| "length_t_spec"\n",length_t_pcast(cum_1));
#else
printf("Terminating |cum_1| "length_t_spec" "
"(== "length_t_spec" - "length_t_spec")\n",
length_t_pcast(cum_1_pos-cum_1_neg),
length_t_pcast(cum_1_pos),
length_t_pcast(cum_1_neg));
#endif
fflush(stdout);
}
#endif

/*:163*/
#line 1649 "./jbmr.w"

num_reject_by_cum_1++;
break;
}

/*59:*/
#line 1683 "./jbmr.w"

#if BL==0
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 1685 "./jbmr.w"

#endif

/*:59*//*79:*/
#line 2131 "./jbmr.w"

#if BL==1
if(t2ip1!=t[3]){
switch(e[0][ec[0]].scheme_id){
case 0:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[3])?0:2;break;
case 4:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[4])?5:8;break;
default:errorif(1,"Non exhaustive switch: %d",e[0][ec[0]].scheme_id);
}
/*165:*/
#line 3833 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3836 "./jbmr.w"
printf("base_scheme5 == %d\n",base_scheme[5]);
fflush(stdout);
}
#endif

/*:165*/
#line 2139 "./jbmr.w"

/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2140 "./jbmr.w"

}
#endif


/*:79*//*86:*/
#line 2507 "./jbmr.w"

#if BL==2
if(t2ip1!=t[5]){
int i1,i2,i4;
switch(base_scheme[7]= e[1][ec[1]].scheme_id){
case 2:i1= 1;i2= 2;i4= 3;break;
case 5:i1= 6,i2= 5,i4= 4;break;
case 9:i1= 1,i2= 2,i4= 5;break;
default:errorif(1,"Got to 4-change in base scheme %d",base_scheme[7]);
i1= i2= i4= -1;
break;
}
if(tour_inorder(t[i1],t[i2],t2ip1,t[i4])){
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2520 "./jbmr.w"

}
}
#endif


/*:86*//*97:*/
#line 2860 "./jbmr.w"

#if BL==3
if(t[two_i]==tour_prev(t[1]))t2ip2= tour_next(t2ip1);
else t2ip2= tour_prev(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 2864 "./jbmr.w"

#endif


/*:97*/
#line 1654 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
en[BL]= enbl;
}else{
num_reject_pre_e_build++;
}

/*:56*/
#line 2792 "./jbmr.w"

}
#undef BL
if(en[3]>0){
/*101:*/
#line 2951 "./jbmr.w"

{int i,best_i;
length_t best_len;
/*164:*/
#line 3804 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
int i;
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3808 "./jbmr.w"
printf("go deeper candidates begin\n");
for(i= 0;i<en[3];i++){
#if !SPLIT_GAIN_VAR
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3811 "./jbmr.w"
printf("%d %d "length_t_spec" s%d\n",
e[3][i].t2ip1,
e[3][i].t2ip2,
length_t_pcast(e[3][i].gain),
e[3][i].scheme_id);
#else
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3817 "./jbmr.w"
printf("%d %d "length_t_spec" (=="length_t_spec"-"
length_t_spec") s%d\n",
e[3][i].t2ip1,
e[3][i].t2ip2,
length_t_pcast(e[3][i].gain_pos-e[3][i].gain_neg),
length_t_pcast(e[3][i].gain_pos),
length_t_pcast(e[3][i].gain_neg),
e[3][i].scheme_id);
#endif
}
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3827 "./jbmr.w"
printf("go deeper candidates end\n");
fflush(stdout);
}
#endif

/*:164*/
#line 2954 "./jbmr.w"

best_i= 0;
best_len= e[3][0].gain_for_comparison;
for(i= 1;i<en[3];i++){
if(best_len<e[3][i].gain_for_comparison){
best_i= i;
best_len= e[3][i].gain_for_comparison;
}
}
if(best_len==0){errorif(1,"Shouldn't be going deeper.");}
#if !SPLIT_GAIN_VAR
cum_gain= e[3][best_i].gain;
#else
cum_gain_pos= e[3][best_i].gain_pos;
cum_gain_neg= e[3][best_i].gain_neg;
#endif
t[two_i+1]= e[3][best_i].t2ip1;
t[two_i+2]= e[3][best_i].t2ip2;
tour_flip_arb(t[1],t[two_i],t[two_i+1],t[two_i+2]);
/*112:*/
#line 3164 "./jbmr.w"


/*:112*//*121:*/
#line 3265 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
dict_insert(tabu,t+two_i);
#endif

/*:121*//*131:*/
#line 3422 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
tabu_hash_add(tabu_hash,t[two_i],t[two_i+1]);
#endif


/*:131*/
#line 2973 "./jbmr.w"

two_i+= 2;
generic_flips_made++;
/*145:*/
#line 3544 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips made: %d\n",generic_flips_made);
fflush(stdout);
}
#endif

/*:145*/
#line 2976 "./jbmr.w"

}

/*:101*/
#line 2796 "./jbmr.w"

}else{
/*102:*/
#line 2990 "./jbmr.w"

if(best_gain==0){
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2992 "./jbmr.w"

}else if(best_scheme_id==13){
/*103:*/
#line 3001 "./jbmr.w"

{
int low_j,best_is_prefix;
errorif(best_gain<=0,"Bad best_scheme_id == 13");
best_is_prefix= t[best_two_i+1]==best_exit_a
&&t[best_two_i+2]==best_exit_b;
low_j= best_two_i+(best_is_prefix?2:0);
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3008 "./jbmr.w"

if(!best_is_prefix){
tour_flip_arb(t[1],t[best_two_i],best_exit_a,best_exit_b);
}
/*73:*/
#line 2028 "./jbmr.w"

{int i;
for(i= 1;i<=best_two_i;i++){
mark_dirty(t[i]);
}
mark_dirty(best_exit_a);
mark_dirty(best_exit_b);
}

/*:73*//*74:*/
#line 2056 "./jbmr.w"

if(iteration>0){
const int more_log= 4+best_two_i;
/*75:*/
#line 2073 "./jbmr.w"

if(more_log>=change_log_max_alloc){
do{
change_log_max_alloc*= 2;
}while(more_log>=change_log_max_alloc);
change_log= (int*)mem_realloc(change_log,sizeof(int)*change_log_max_alloc);
}

/*:75*/
#line 2059 "./jbmr.w"

{int j;
for(j= 1;j<=best_two_i;j++){
write_log(t[j]);
}
}
write_log(best_exit_a);
write_log(best_exit_b);
write_log(scheme_id);
write_log(3+best_two_i);
}


/*:74*/
#line 3012 "./jbmr.w"

/*173:*/
#line 3903 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= best_two_i+2;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3906 "./jbmr.w"

#endif

/*:173*/
#line 3013 "./jbmr.w"

more_backtracking= 0;
}

/*:103*/
#line 2994 "./jbmr.w"

}

/*:102*/
#line 2798 "./jbmr.w"

go_deeper= 0;
}
}
/*113:*/
#line 3167 "./jbmr.w"


/*:113*//*122:*/
#line 3274 "./jbmr.w"

#if defined(TABU_SPLAY)
dict_delete_all(tabu,NULL);
#endif

/*:122*//*132:*/
#line 3429 "./jbmr.w"

#if defined(TABU_HASH)
tabu_hash_make_empty(tabu_hash);
#endif

/*:132*/
#line 2802 "./jbmr.w"

}

/*:93*/
#line 2387 "./jbmr.w"

/*83:*/
#line 2425 "./jbmr.w"

if(more_backtracking){
if(best_gain>0&&scheme_num_cities[best_scheme_id]==6){
if(best_exit_a==t[5]&&best_exit_b==t[6]){
/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 2429 "./jbmr.w"

}else{
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2431 "./jbmr.w"

t[5]= best_exit_a;t[6]= best_exit_b;
scheme_id= best_scheme_id;
/*84:*/
#line 2448 "./jbmr.w"

{int i,n= scheme_max[scheme_id],*s= &scheme[scheme_id][0];
/*149:*/
#line 3584 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Implement scheme %d\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3588 "./jbmr.w"

fflush(stdout);
}
#endif

/*:149*/
#line 2450 "./jbmr.w"

for(i= 0;i<n;i+= 4){
tour_flip_arb(t[s[i]],t[s[i+1]],t[s[i+2]],t[s[i+3]]);
}
}

/*:84*/
#line 2434 "./jbmr.w"

}
/*73:*/
#line 2028 "./jbmr.w"

{int i;
for(i= 1;i<=best_two_i;i++){
mark_dirty(t[i]);
}
mark_dirty(best_exit_a);
mark_dirty(best_exit_b);
}

/*:73*//*74:*/
#line 2056 "./jbmr.w"

if(iteration>0){
const int more_log= 4+best_two_i;
/*75:*/
#line 2073 "./jbmr.w"

if(more_log>=change_log_max_alloc){
do{
change_log_max_alloc*= 2;
}while(more_log>=change_log_max_alloc);
change_log= (int*)mem_realloc(change_log,sizeof(int)*change_log_max_alloc);
}

/*:75*/
#line 2059 "./jbmr.w"

{int j;
for(j= 1;j<=best_two_i;j++){
write_log(t[j]);
}
}
write_log(best_exit_a);
write_log(best_exit_b);
write_log(scheme_id);
write_log(3+best_two_i);
}


/*:74*/
#line 2436 "./jbmr.w"

/*171:*/
#line 3889 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 6;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3892 "./jbmr.w"

#endif

/*:171*/
#line 2437 "./jbmr.w"

more_backtracking= 0;
}else{
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2440 "./jbmr.w"

}
}

/*:83*/
#line 2388 "./jbmr.w"

}else{
#define BL 2
{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
const length_t cluster_dist= this_move->cluster_dist;
#else
const length_t cluster_dist= 0;
#endif
/*56:*/
#line 1623 "./jbmr.w"

en[BL]= ec[BL]= 0;
if(CAREFUL_OP(cum_gain,>,cluster_dist+best_gain)){
int i,t2ip1,t2ip2,enbl,*neighbour_list,nn_bound;
#if SPLIT_GAIN_VAR
length_t cum_1_pos,cum_1_neg,cum_2_pos,cum_2_neg;
#else
length_t cum_1,cum_2;
#endif
/*156:*/
#line 3664 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 400
if(verbose>=400){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3667 "./jbmr.w"

printf("%d %d "length_t_spec" "length_t_spec" s%d\n",t[two_i-1],t[two_i],
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_gain),
#else
length_t_pcast(cum_gain_pos-cum_gain_neg),
#endif
length_t_pcast(best_gain),scheme_id);
fflush(stdout);
}
#endif



/*:156*/
#line 1632 "./jbmr.w"



#if SPLIT_GAIN_VAR
cum_1_pos= cum_gain_pos;
#endif

neighbour_list= nn_list(t[two_i],&nn_bound);
for(i= 0,enbl= 0;i<nn_bound;i++){
t2ip1= neighbour_list[i];
#if SPLIT_GAIN_VAR
cum_1_neg= cum_gain_neg+cost(t[two_i],t2ip1);
#else
cum_1= cum_gain-cost(t[two_i],t2ip1);
#endif

if(CAREFUL_OP(cum_1,<=,best_gain)){
/*163:*/
#line 3786 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3789 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("Terminating |cum_1| "length_t_spec"\n",length_t_pcast(cum_1));
#else
printf("Terminating |cum_1| "length_t_spec" "
"(== "length_t_spec" - "length_t_spec")\n",
length_t_pcast(cum_1_pos-cum_1_neg),
length_t_pcast(cum_1_pos),
length_t_pcast(cum_1_neg));
#endif
fflush(stdout);
}
#endif

/*:163*/
#line 1649 "./jbmr.w"

num_reject_by_cum_1++;
break;
}

/*59:*/
#line 1683 "./jbmr.w"

#if BL==0
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 1685 "./jbmr.w"

#endif

/*:59*//*79:*/
#line 2131 "./jbmr.w"

#if BL==1
if(t2ip1!=t[3]){
switch(e[0][ec[0]].scheme_id){
case 0:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[3])?0:2;break;
case 4:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[4])?5:8;break;
default:errorif(1,"Non exhaustive switch: %d",e[0][ec[0]].scheme_id);
}
/*165:*/
#line 3833 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3836 "./jbmr.w"
printf("base_scheme5 == %d\n",base_scheme[5]);
fflush(stdout);
}
#endif

/*:165*/
#line 2139 "./jbmr.w"

/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2140 "./jbmr.w"

}
#endif


/*:79*//*86:*/
#line 2507 "./jbmr.w"

#if BL==2
if(t2ip1!=t[5]){
int i1,i2,i4;
switch(base_scheme[7]= e[1][ec[1]].scheme_id){
case 2:i1= 1;i2= 2;i4= 3;break;
case 5:i1= 6,i2= 5,i4= 4;break;
case 9:i1= 1,i2= 2,i4= 5;break;
default:errorif(1,"Got to 4-change in base scheme %d",base_scheme[7]);
i1= i2= i4= -1;
break;
}
if(tour_inorder(t[i1],t[i2],t2ip1,t[i4])){
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2520 "./jbmr.w"

}
}
#endif


/*:86*//*97:*/
#line 2860 "./jbmr.w"

#if BL==3
if(t[two_i]==tour_prev(t[1]))t2ip2= tour_next(t2ip1);
else t2ip2= tour_prev(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 2864 "./jbmr.w"

#endif


/*:97*/
#line 1654 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
en[BL]= enbl;
}else{
num_reject_pre_e_build++;
}

/*:56*/
#line 2397 "./jbmr.w"

}
/*68:*/
#line 1897 "./jbmr.w"

sort(e[BL],(size_t)en[BL],sizeof(eligible_t),cmp_eligible);

/*:68*/
#line 2399 "./jbmr.w"

#undef BL
/*91:*/
#line 2712 "./jbmr.w"

for(ec[2]= 0;more_backtracking&&ec[2]<en[2];ec[2]++){
eligible_t*this_move= &e[2][ec[2]];
t[7]= this_move->t2ip1;
t[8]= this_move->t2ip2;
#if !SPLIT_GAIN_VAR
cum_gain= this_move->gain;
#else
cum_gain_pos= this_move->gain_pos;
cum_gain_neg= this_move->gain_neg;
#endif
two_i= 8;
/*175:*/
#line 3917 "./jbmr.w"

#if TRACK_DEPTHS
if(probe_depth<two_i+2)(probe_depth= two_i+2);
#endif


/*:175*/
#line 2724 "./jbmr.w"

scheme_id= this_move->scheme_id;
/*84:*/
#line 2448 "./jbmr.w"

{int i,n= scheme_max[scheme_id],*s= &scheme[scheme_id][0];
/*149:*/
#line 3584 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Implement scheme %d\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3588 "./jbmr.w"

fflush(stdout);
}
#endif

/*:149*/
#line 2450 "./jbmr.w"

for(i= 0;i<n;i+= 4){
tour_flip_arb(t[s[i]],t[s[i+1]],t[s[i+2]],t[s[i+3]]);
}
}

/*:84*/
#line 2726 "./jbmr.w"

/*93:*/
#line 2775 "./jbmr.w"

{int go_deeper;
last_special_two_i= two_i;
generic_flips_made= 0;
/*111:*/
#line 3161 "./jbmr.w"


/*:111*//*120:*/
#line 3256 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{
int i;
for(i= 2;i<two_i;i+= 2)dict_insert(tabu,t+i);
}
#endif

/*:120*//*130:*/
#line 3413 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{
int i;
for(i= 2;i<two_i;i+= 2)tabu_hash_add(tabu_hash,t[i],t[i+1]);
}
#endif

/*:130*/
#line 2779 "./jbmr.w"

/*147:*/
#line 3563 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 175
if(verbose>=175){
printf("Start generic search\n");
fflush(stdout);
}
#endif


/*:147*/
#line 2780 "./jbmr.w"

for(go_deeper= 1;go_deeper;){
/*94:*/
#line 2809 "./jbmr.w"

#if defined(JBMR_LIMIT_PROBE_DEPTH)
if(generic_flips_made>=max_generic_flips){
/*187:*/
#line 4026 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 75
if(verbose>=75){
printf(" hit max generic flips: %d >= %d\n",
generic_flips_made,max_generic_flips);
}
#endif

/*:187*/
#line 2812 "./jbmr.w"

/*102:*/
#line 2990 "./jbmr.w"

if(best_gain==0){
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2992 "./jbmr.w"

}else if(best_scheme_id==13){
/*103:*/
#line 3001 "./jbmr.w"

{
int low_j,best_is_prefix;
errorif(best_gain<=0,"Bad best_scheme_id == 13");
best_is_prefix= t[best_two_i+1]==best_exit_a
&&t[best_two_i+2]==best_exit_b;
low_j= best_two_i+(best_is_prefix?2:0);
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3008 "./jbmr.w"

if(!best_is_prefix){
tour_flip_arb(t[1],t[best_two_i],best_exit_a,best_exit_b);
}
/*73:*/
#line 2028 "./jbmr.w"

{int i;
for(i= 1;i<=best_two_i;i++){
mark_dirty(t[i]);
}
mark_dirty(best_exit_a);
mark_dirty(best_exit_b);
}

/*:73*//*74:*/
#line 2056 "./jbmr.w"

if(iteration>0){
const int more_log= 4+best_two_i;
/*75:*/
#line 2073 "./jbmr.w"

if(more_log>=change_log_max_alloc){
do{
change_log_max_alloc*= 2;
}while(more_log>=change_log_max_alloc);
change_log= (int*)mem_realloc(change_log,sizeof(int)*change_log_max_alloc);
}

/*:75*/
#line 2059 "./jbmr.w"

{int j;
for(j= 1;j<=best_two_i;j++){
write_log(t[j]);
}
}
write_log(best_exit_a);
write_log(best_exit_b);
write_log(scheme_id);
write_log(3+best_two_i);
}


/*:74*/
#line 3012 "./jbmr.w"

/*173:*/
#line 3903 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= best_two_i+2;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3906 "./jbmr.w"

#endif

/*:173*/
#line 3013 "./jbmr.w"

more_backtracking= 0;
}

/*:103*/
#line 2994 "./jbmr.w"

}

/*:102*/
#line 2813 "./jbmr.w"

go_deeper= 0;
break;
}
#endif

/*:94*/
#line 2782 "./jbmr.w"

/*175:*/
#line 3917 "./jbmr.w"

#if TRACK_DEPTHS
if(probe_depth<two_i+2)(probe_depth= two_i+2);
#endif


/*:175*/
#line 2783 "./jbmr.w"

/*26:*/
#line 842 "./jbmr.w"

if(two_i+3>=t_max_alloc){
#if defined(TABU_SPLAY)
int*old_t= t;
#endif
do{
t_max_alloc*= 2;
}while(two_i+3>=t_max_alloc);
t= (int*)mem_realloc(t,sizeof(int)*t_max_alloc);
/*123:*/
#line 3311 "./jbmr.w"

#if defined(TABU_SPLAY)
{int*env[2];
env[0]= old_t;
env[1]= t;
dict_update_all(tabu,move_t,env);
}
#endif

/*:123*/
#line 851 "./jbmr.w"

}


/*:26*/
#line 2784 "./jbmr.w"

#define BL 3
{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
const length_t cluster_dist= decluster_d(t[1],t[two_i]);
#else
const length_t cluster_dist= 0;
#endif
/*56:*/
#line 1623 "./jbmr.w"

en[BL]= ec[BL]= 0;
if(CAREFUL_OP(cum_gain,>,cluster_dist+best_gain)){
int i,t2ip1,t2ip2,enbl,*neighbour_list,nn_bound;
#if SPLIT_GAIN_VAR
length_t cum_1_pos,cum_1_neg,cum_2_pos,cum_2_neg;
#else
length_t cum_1,cum_2;
#endif
/*156:*/
#line 3664 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 400
if(verbose>=400){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3667 "./jbmr.w"

printf("%d %d "length_t_spec" "length_t_spec" s%d\n",t[two_i-1],t[two_i],
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_gain),
#else
length_t_pcast(cum_gain_pos-cum_gain_neg),
#endif
length_t_pcast(best_gain),scheme_id);
fflush(stdout);
}
#endif



/*:156*/
#line 1632 "./jbmr.w"



#if SPLIT_GAIN_VAR
cum_1_pos= cum_gain_pos;
#endif

neighbour_list= nn_list(t[two_i],&nn_bound);
for(i= 0,enbl= 0;i<nn_bound;i++){
t2ip1= neighbour_list[i];
#if SPLIT_GAIN_VAR
cum_1_neg= cum_gain_neg+cost(t[two_i],t2ip1);
#else
cum_1= cum_gain-cost(t[two_i],t2ip1);
#endif

if(CAREFUL_OP(cum_1,<=,best_gain)){
/*163:*/
#line 3786 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3789 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("Terminating |cum_1| "length_t_spec"\n",length_t_pcast(cum_1));
#else
printf("Terminating |cum_1| "length_t_spec" "
"(== "length_t_spec" - "length_t_spec")\n",
length_t_pcast(cum_1_pos-cum_1_neg),
length_t_pcast(cum_1_pos),
length_t_pcast(cum_1_neg));
#endif
fflush(stdout);
}
#endif

/*:163*/
#line 1649 "./jbmr.w"

num_reject_by_cum_1++;
break;
}

/*59:*/
#line 1683 "./jbmr.w"

#if BL==0
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 1685 "./jbmr.w"

#endif

/*:59*//*79:*/
#line 2131 "./jbmr.w"

#if BL==1
if(t2ip1!=t[3]){
switch(e[0][ec[0]].scheme_id){
case 0:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[3])?0:2;break;
case 4:base_scheme[5]= tour_inorder(t[1],t[2],t2ip1,t[4])?5:8;break;
default:errorif(1,"Non exhaustive switch: %d",e[0][ec[0]].scheme_id);
}
/*165:*/
#line 3833 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3836 "./jbmr.w"
printf("base_scheme5 == %d\n",base_scheme[5]);
fflush(stdout);
}
#endif

/*:165*/
#line 2139 "./jbmr.w"

/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2140 "./jbmr.w"

}
#endif


/*:79*//*86:*/
#line 2507 "./jbmr.w"

#if BL==2
if(t2ip1!=t[5]){
int i1,i2,i4;
switch(base_scheme[7]= e[1][ec[1]].scheme_id){
case 2:i1= 1;i2= 2;i4= 3;break;
case 5:i1= 6,i2= 5,i4= 4;break;
case 9:i1= 1,i2= 2,i4= 5;break;
default:errorif(1,"Got to 4-change in base scheme %d",base_scheme[7]);
i1= i2= i4= -1;
break;
}
if(tour_inorder(t[i1],t[i2],t2ip1,t[i4])){
/*60:*/
#line 1715 "./jbmr.w"

#if defined(JBMR_UNROLL_PREV_NEXT_LOOP)
#error "JBMR_UNROLL_PREV_NEXT_LOOP is not implemented"
#else
{int which_neighbour;
for(which_neighbour= 0;which_neighbour<2;which_neighbour++){
t2ip2= (tour_neighbour[which_neighbour])(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 1722 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
}
#endif

/*:60*/
#line 2520 "./jbmr.w"

}
}
#endif


/*:86*//*97:*/
#line 2860 "./jbmr.w"

#if BL==3
if(t[two_i]==tour_prev(t[1]))t2ip2= tour_next(t2ip1);
else t2ip2= tour_prev(t2ip1);
/*63:*/
#line 1747 "./jbmr.w"

#if BL==0
if(t[2]!=t2ip2){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 1750 "./jbmr.w"

}
#endif

/*:63*//*80:*/
#line 2196 "./jbmr.w"

#if BL==1
if(!(
(t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int is_illegal= 0;
switch(base_scheme[5]){
case 0:

if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 0;




is_illegal= t[2]==t2ip1||t[1]==t2ip2;
}else{
base_scheme[6]= 1;





is_illegal= t[2]==t2ip2||t[1]==t2ip1||t[4]==t2ip2
||t[1]==t2ip2;
}
break;
case 2:
base_scheme[6]= 2;
is_illegal= tour_inorder(t[3],t[4],t2ip1,t2ip2);







break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[6]= 5;











}else{
base_scheme[6]= 7;




is_illegal= t2ip2==t[1]||t[1]==t[4];
}
break;
case 8:
if(tour_inorder(t[4],t[3],t2ip2,t2ip1)){
base_scheme[6]= 8;













}else{
base_scheme[6]= 9;










is_illegal= t2ip2==t[2];
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[5]);
}
if(!is_illegal){
/*166:*/
#line 3842 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 1000
if(verbose>=1000){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3845 "./jbmr.w"
printf("base_scheme6 == %d\n",base_scheme[6]);
fflush(stdout);
}
#endif


/*:166*/
#line 2292 "./jbmr.w"

/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2293 "./jbmr.w"

}
}
#endif 

/*:80*//*87:*/
#line 2574 "./jbmr.w"

#if BL==2
if(!(
(t2ip2==t[6])
||(t2ip1==t[4]&&t2ip2==t[5])
||(t2ip1==t[5]&&t2ip2==t[4])
||(t2ip1==t[2]&&t2ip2==t[3])
||(t2ip1==t[3]&&t2ip2==t[2]))){
int infeasible_4_change,is_illegal= 0;
switch(base_scheme[7]){
case 2:
if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 2;
is_illegal= t2ip2==t[4]||t2ip2==t[1];
}else{
base_scheme[8]= 3;


}
break;
case 5:
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 5;


}else{
base_scheme[8]= 6;
is_illegal= t2ip2==t[3];


}
break;
case 9:
if(tour_inorder(t[1],t[2],t2ip1,t[4])){
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
base_scheme[8]= 9;





}else{
base_scheme[8]= 10;
is_illegal= t2ip2==t[3];



}
}else{




if(tour_inorder(t[1],t[2],t2ip1,t2ip2)){
base_scheme[8]= 11;
is_illegal= t2ip2==t[6];


}else{
base_scheme[8]= 12;
is_illegal= t2ip2==t[4];


}
}
break;
default:errorif(1,"Non-exhaustive switch: %d",base_scheme[7]);
}
if(!is_illegal){
/*88:*/
#line 2655 "./jbmr.w"

{int i,*sc,sn;
t[7]= t2ip1;
t[8]= t2ip2;
infeasible_4_change= 0;
sc= &scheme_feas_check[base_scheme[8]][0];
sn= scheme_feas_n[base_scheme[8]];
for(i= 0;i<sn;i+= 2){
if(t[sc[i]]==t[sc[i+1]]){infeasible_4_change= 1;break;}
}
}

/*:88*/
#line 2643 "./jbmr.w"

if(!infeasible_4_change){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2645 "./jbmr.w"

}
}
}
#endif

/*:87*//*99:*/
#line 2915 "./jbmr.w"

#if BL==3
if(t2ip2!=t[1]&&t2ip2!=t[two_i]){
int is_tabu= 0;
/*110:*/
#line 3140 "./jbmr.w"

#if defined(TABU_LINEAR)
#if defined(TABU_JBMR)
{
int i;
for(i= 2,is_tabu= 0;i<two_i;i+= 2){
if((t2ip1==t[i]&&t2ip2==t[i+1])
||(t2ip1==t[i+1]&&t2ip2==t[i])){
is_tabu= 1;
break;
}
}
}
#elif defined(TABU_Papadimitriou)
{errorif(1,"TABU_Papadimitriou is not implemented yet");}
#else
#error "Need one of TABU_JBMR or TABU_Papadimitriou defined"
#endif
#endif 

/*:110*//*119:*/
#line 3238 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
{int edge[2];
if(t2ip1<t2ip2){edge[0]= t2ip2;edge[1]= t2ip1;}
else{edge[0]= t2ip1;edge[1]= t2ip2;}
is_tabu= dict_find(tabu,edge)!=NULL;
}
#endif

/*:119*//*129:*/
#line 3407 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
{is_tabu= tabu_hash_includes(tabu_hash,t2ip1,t2ip2);}
#endif

/*:129*/
#line 2919 "./jbmr.w"

if(!is_tabu){
/*64:*/
#line 1763 "./jbmr.w"

{
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST || JBMR_DECLUSTER_IN_GREEDY
const length_t cluster_dist= decluster_d(t[1],t2ip2);
/*159:*/
#line 3746 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 501 && (JBMR_DECLUSTER_IN_ELIGIBILITY_TEST||JBMR_DECLUSTER_IN_GREEDY)
if(verbose>=501){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3749 "./jbmr.w"

printf(" v---- next clust_dist==%f\n",(double)cluster_dist);
}
#endif

/*:159*/
#line 1767 "./jbmr.w"

#endif

#if !SPLIT_GAIN_VAR
cum_2= cum_1+cost(t2ip1,t2ip2);
#else 
cum_2_pos= cum_1_pos+cost(t2ip1,t2ip2);
cum_2_neg= cum_1_neg;
#endif 

#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
if(CAREFUL_OP(cum_2,<=,cluster_dist+best_gain)){
/*160:*/
#line 3755 "./jbmr.w"

#if JBMR_MAX_VERBOSE
num_reject_by_decluster++;
#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3760 "./jbmr.w"

printf("%d: %d %d "length_t_spec" s%d rejected (#%d), clust_dist==%f\n",
enbl,t2ip1,t2ip2,
#if !SPLIT_GAIN_VAR
length_t_pcast(cum_2),
#else
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id,
num_reject_by_decluster,
(double)cluster_dist);
fflush(stdout);
}
#endif
#endif

/*:160*/
#line 1779 "./jbmr.w"

}else
#endif

{
/*66:*/
#line 1832 "./jbmr.w"

#if BL==0
if(tour_inorder(t[1],t[2],t2ip2,t2ip1)){
e[BL][enbl].scheme_id= 4;
if(t[1]!=t[4]){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 1837 "./jbmr.w"

}
}else{
e[BL][enbl].scheme_id= 0;
}
#endif



/*:66*//*81:*/
#line 2357 "./jbmr.w"

#if BL==1
if(scheme_num_cities[e[BL][enbl].scheme_id= base_scheme[6]]==6){
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2360 "./jbmr.w"

}
#endif

/*:81*//*90:*/
#line 2695 "./jbmr.w"

#if BL==2
e[BL][enbl].scheme_id= base_scheme[8];
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2698 "./jbmr.w"

#endif

/*:90*//*100:*/
#line 2930 "./jbmr.w"

#if BL==3
e[BL][enbl].scheme_id= 13;
/*67:*/
#line 1854 "./jbmr.w"

{const length_t cost_phantom= cost(t[1],t2ip2);
#if !SPLIT_GAIN_VAR
const length_t cum_exit_now= cum_2-cost_phantom;
#endif

if(
#if LENGTH_TYPE_IS_EXACT
cum_exit_now>best_gain
#elif SPLIT_GAIN_VAR
cum_2_pos>best_gain_with_slop+cum_2_neg+cost_phantom
#else
cum_exit_now>best_gain_with_slop
#endif
)
{

#if SPLIT_GAIN_VAR
best_gain= cum_2_pos-cum_2_neg-cost_phantom;
#else
best_gain= cum_exit_now;
#endif
#if !LENGTH_TYPE_IS_EXACT
best_gain_with_slop= best_gain+instance_epsilon;
#endif

best_two_i= two_i;
best_exit_a= t2ip1;
best_exit_b= t2ip2;
best_scheme_id= e[BL][enbl].scheme_id;
/*148:*/
#line 3573 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 200
if(verbose>=200){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3576 "./jbmr.w"

printf("best_gain = "length_t_spec" %d %d s%d\n",
length_t_pcast(best_gain),best_exit_a,best_exit_b,best_scheme_id);
fflush(stdout);
}
#endif

/*:148*/
#line 1884 "./jbmr.w"

}
}

/*:67*/
#line 2933 "./jbmr.w"

#endif

/*:100*/
#line 1784 "./jbmr.w"

e[BL][enbl].t2ip1= t2ip1;
e[BL][enbl].t2ip2= t2ip2;

#if !SPLIT_GAIN_VAR
e[BL][enbl].gain_for_comparison= e[BL][enbl].gain= cum_2;
#else
e[BL][enbl].gain_for_comparison= cum_2_pos-cum_2_neg;
e[BL][enbl].gain_pos= cum_2_pos;
e[BL][enbl].gain_neg= cum_2_neg;
#endif

#if JBMR_DECLUSTER_IN_GREEDY
e[BL][enbl].gain_for_comparison-= cluster_dist;
#endif
#if JBMR_DECLUSTER_IN_ELIGIBILITY_TEST
e[BL][enbl].cluster_dist= cluster_dist;
#endif

/*158:*/
#line 3725 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3728 "./jbmr.w"

#if !SPLIT_GAIN_VAR
printf("%d: %d %d "length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2),
#else
printf("%d: %d %d "length_t_spec"-"length_t_spec"="length_t_spec" s%d\n",
enbl,t2ip1,t2ip2,
length_t_pcast(cum_2_pos),
length_t_pcast(cum_2_neg),
length_t_pcast(cum_2_pos-cum_2_neg),
#endif
e[BL][enbl].scheme_id);
fflush(stdout);
}
#endif

/*:158*/
#line 1803 "./jbmr.w"

enbl++;
}
}

/*:64*/
#line 2921 "./jbmr.w"

}
}
#endif


/*:99*/
#line 2864 "./jbmr.w"

#endif


/*:97*/
#line 1654 "./jbmr.w"

if(BL==2&&no_extra_backtrack&&enbl)break;
}
en[BL]= enbl;
}else{
num_reject_pre_e_build++;
}

/*:56*/
#line 2792 "./jbmr.w"

}
#undef BL
if(en[3]>0){
/*101:*/
#line 2951 "./jbmr.w"

{int i,best_i;
length_t best_len;
/*164:*/
#line 3804 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 500
if(verbose>=500){
int i;
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3808 "./jbmr.w"
printf("go deeper candidates begin\n");
for(i= 0;i<en[3];i++){
#if !SPLIT_GAIN_VAR
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3811 "./jbmr.w"
printf("%d %d "length_t_spec" s%d\n",
e[3][i].t2ip1,
e[3][i].t2ip2,
length_t_pcast(e[3][i].gain),
e[3][i].scheme_id);
#else
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3817 "./jbmr.w"
printf("%d %d "length_t_spec" (=="length_t_spec"-"
length_t_spec") s%d\n",
e[3][i].t2ip1,
e[3][i].t2ip2,
length_t_pcast(e[3][i].gain_pos-e[3][i].gain_neg),
length_t_pcast(e[3][i].gain_pos),
length_t_pcast(e[3][i].gain_neg),
e[3][i].scheme_id);
#endif
}
/*167:*/
#line 3852 "./jbmr.w"

#if JBMR_MAX_VERBOSE
{int i;for(i= 0;i<two_i;i++)printf(" ");}
#endif

/*:167*/
#line 3827 "./jbmr.w"
printf("go deeper candidates end\n");
fflush(stdout);
}
#endif

/*:164*/
#line 2954 "./jbmr.w"

best_i= 0;
best_len= e[3][0].gain_for_comparison;
for(i= 1;i<en[3];i++){
if(best_len<e[3][i].gain_for_comparison){
best_i= i;
best_len= e[3][i].gain_for_comparison;
}
}
if(best_len==0){errorif(1,"Shouldn't be going deeper.");}
#if !SPLIT_GAIN_VAR
cum_gain= e[3][best_i].gain;
#else
cum_gain_pos= e[3][best_i].gain_pos;
cum_gain_neg= e[3][best_i].gain_neg;
#endif
t[two_i+1]= e[3][best_i].t2ip1;
t[two_i+2]= e[3][best_i].t2ip2;
tour_flip_arb(t[1],t[two_i],t[two_i+1],t[two_i+2]);
/*112:*/
#line 3164 "./jbmr.w"


/*:112*//*121:*/
#line 3265 "./jbmr.w"

#if defined(TABU_SPLAY) && defined(TABU_JBMR)
dict_insert(tabu,t+two_i);
#endif

/*:121*//*131:*/
#line 3422 "./jbmr.w"

#if defined(TABU_HASH) && defined(TABU_JBMR)
tabu_hash_add(tabu_hash,t[two_i],t[two_i+1]);
#endif


/*:131*/
#line 2973 "./jbmr.w"

two_i+= 2;
generic_flips_made++;
/*145:*/
#line 3544 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips made: %d\n",generic_flips_made);
fflush(stdout);
}
#endif

/*:145*/
#line 2976 "./jbmr.w"

}

/*:101*/
#line 2796 "./jbmr.w"

}else{
/*102:*/
#line 2990 "./jbmr.w"

if(best_gain==0){
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2992 "./jbmr.w"

}else if(best_scheme_id==13){
/*103:*/
#line 3001 "./jbmr.w"

{
int low_j,best_is_prefix;
errorif(best_gain<=0,"Bad best_scheme_id == 13");
best_is_prefix= t[best_two_i+1]==best_exit_a
&&t[best_two_i+2]==best_exit_b;
low_j= best_two_i+(best_is_prefix?2:0);
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3008 "./jbmr.w"

if(!best_is_prefix){
tour_flip_arb(t[1],t[best_two_i],best_exit_a,best_exit_b);
}
/*73:*/
#line 2028 "./jbmr.w"

{int i;
for(i= 1;i<=best_two_i;i++){
mark_dirty(t[i]);
}
mark_dirty(best_exit_a);
mark_dirty(best_exit_b);
}

/*:73*//*74:*/
#line 2056 "./jbmr.w"

if(iteration>0){
const int more_log= 4+best_two_i;
/*75:*/
#line 2073 "./jbmr.w"

if(more_log>=change_log_max_alloc){
do{
change_log_max_alloc*= 2;
}while(more_log>=change_log_max_alloc);
change_log= (int*)mem_realloc(change_log,sizeof(int)*change_log_max_alloc);
}

/*:75*/
#line 2059 "./jbmr.w"

{int j;
for(j= 1;j<=best_two_i;j++){
write_log(t[j]);
}
}
write_log(best_exit_a);
write_log(best_exit_b);
write_log(scheme_id);
write_log(3+best_two_i);
}


/*:74*/
#line 3012 "./jbmr.w"

/*173:*/
#line 3903 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= best_two_i+2;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3906 "./jbmr.w"

#endif

/*:173*/
#line 3013 "./jbmr.w"

more_backtracking= 0;
}

/*:103*/
#line 2994 "./jbmr.w"

}

/*:102*/
#line 2798 "./jbmr.w"

go_deeper= 0;
}
}
/*113:*/
#line 3167 "./jbmr.w"


/*:113*//*122:*/
#line 3274 "./jbmr.w"

#if defined(TABU_SPLAY)
dict_delete_all(tabu,NULL);
#endif

/*:122*//*132:*/
#line 3429 "./jbmr.w"

#if defined(TABU_HASH)
tabu_hash_make_empty(tabu_hash);
#endif

/*:132*/
#line 2802 "./jbmr.w"

}

/*:93*/
#line 2727 "./jbmr.w"

/*92:*/
#line 2741 "./jbmr.w"

if(more_backtracking){
if(best_gain>0&&scheme_num_cities[best_scheme_id]==8){
if(best_exit_a==t[7]&&best_exit_b==t[8]){
/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 2745 "./jbmr.w"

}else{
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2747 "./jbmr.w"

t[7]= best_exit_a;t[8]= best_exit_b;
scheme_id= best_scheme_id;
/*84:*/
#line 2448 "./jbmr.w"

{int i,n= scheme_max[scheme_id],*s= &scheme[scheme_id][0];
/*149:*/
#line 3584 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Implement scheme %d\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3588 "./jbmr.w"

fflush(stdout);
}
#endif

/*:149*/
#line 2450 "./jbmr.w"

for(i= 0;i<n;i+= 4){
tour_flip_arb(t[s[i]],t[s[i+1]],t[s[i+2]],t[s[i+3]]);
}
}

/*:84*/
#line 2750 "./jbmr.w"

}
/*73:*/
#line 2028 "./jbmr.w"

{int i;
for(i= 1;i<=best_two_i;i++){
mark_dirty(t[i]);
}
mark_dirty(best_exit_a);
mark_dirty(best_exit_b);
}

/*:73*//*74:*/
#line 2056 "./jbmr.w"

if(iteration>0){
const int more_log= 4+best_two_i;
/*75:*/
#line 2073 "./jbmr.w"

if(more_log>=change_log_max_alloc){
do{
change_log_max_alloc*= 2;
}while(more_log>=change_log_max_alloc);
change_log= (int*)mem_realloc(change_log,sizeof(int)*change_log_max_alloc);
}

/*:75*/
#line 2059 "./jbmr.w"

{int j;
for(j= 1;j<=best_two_i;j++){
write_log(t[j]);
}
}
write_log(best_exit_a);
write_log(best_exit_b);
write_log(scheme_id);
write_log(3+best_two_i);
}


/*:74*/
#line 2752 "./jbmr.w"

/*172:*/
#line 3896 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 8;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3899 "./jbmr.w"

#endif

/*:172*/
#line 2753 "./jbmr.w"

more_backtracking= 0;
}else{
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2756 "./jbmr.w"

}
}

/*:92*/
#line 2728 "./jbmr.w"

}

/*:91*/
#line 2401 "./jbmr.w"

}
}


/*:82*/
#line 2004 "./jbmr.w"

/*72:*/
#line 2014 "./jbmr.w"

if(best_scheme_id==4){
/*106:*/
#line 3045 "./jbmr.w"

/*105:*/
#line 3036 "./jbmr.w"

if(generic_flips_made){
int low_j= last_special_two_i;
/*104:*/
#line 3021 "./jbmr.w"

{int j;
errorif(low_j<last_special_two_i,"Generic broken! caught at unrolling time");
for(j= two_i;j>low_j;j-= 2){
/*153:*/
#line 3637 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 350
if(verbose>=350){
printf("Rollback generic flip(t%d t%d t%d t%d)\n",1,j,j-1,j-2);
fflush(stdout);
}
#endif

/*:153*/
#line 3025 "./jbmr.w"

tour_flip_arb(t[1],t[j],t[j-1],t[j-2]);
}
generic_flips_made= (low_j-last_special_two_i)/2;
/*146:*/
#line 3553 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 150
if(verbose>=150){
printf("Generic flips remain after rollback: %d\n",generic_flips_made);
fflush(stdout);
}
#endif


/*:146*/
#line 3029 "./jbmr.w"

}

/*:104*/
#line 3039 "./jbmr.w"

}

/*:105*/
#line 3046 "./jbmr.w"

/*107:*/
#line 3057 "./jbmr.w"

if(scheme_id>=0){
int j,*s= scheme[scheme_id];
/*150:*/
#line 3594 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Unrolling the scheme %d changes\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3598 "./jbmr.w"

fflush(stdout);
}
#endif

/*:150*/
#line 3060 "./jbmr.w"

for(j= scheme_max[scheme_id]-4;j>=0;j-= 4){
tour_flip_arb(t[s[j]],t[s[j+3]],t[s[j+2]],t[s[j+1]]);
}
scheme_id= -1;
/*174:*/
#line 3910 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 0;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3913 "./jbmr.w"

#endif

/*:174*/
#line 3065 "./jbmr.w"

}

/*:107*/
#line 3047 "./jbmr.w"


/*:106*/
#line 2016 "./jbmr.w"

t[3]= best_exit_a;t[4]= best_exit_b;
scheme_id= 4;
/*84:*/
#line 2448 "./jbmr.w"

{int i,n= scheme_max[scheme_id],*s= &scheme[scheme_id][0];
/*149:*/
#line 3584 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
printf("Implement scheme %d\n",scheme_id);
/*151:*/
#line 3604 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 300
if(verbose>=300){
int i;
length_t c= 0,b= 0;
printf("t: ");
for(i= 1;i<=two_i;i++){
if(i%2){
if(i>1)c-= cost(t[i],t[i-1]);
}else{
c+= cost(t[i],t[i-1]);
}
printf("%d ",t[i]);
}
b= c-cost(t[1],t[two_i]);
printf(length_t_spec" ",length_t_pcast(c));
printf(length_t_spec"\n",length_t_pcast(b));
fflush(stdout);
}
#endif



/*:151*/
#line 3588 "./jbmr.w"

fflush(stdout);
}
#endif

/*:149*/
#line 2450 "./jbmr.w"

for(i= 0;i<n;i+= 4){
tour_flip_arb(t[s[i]],t[s[i+1]],t[s[i+2]],t[s[i+3]]);
}
}

/*:84*/
#line 2019 "./jbmr.w"

/*73:*/
#line 2028 "./jbmr.w"

{int i;
for(i= 1;i<=best_two_i;i++){
mark_dirty(t[i]);
}
mark_dirty(best_exit_a);
mark_dirty(best_exit_b);
}

/*:73*//*74:*/
#line 2056 "./jbmr.w"

if(iteration>0){
const int more_log= 4+best_two_i;
/*75:*/
#line 2073 "./jbmr.w"

if(more_log>=change_log_max_alloc){
do{
change_log_max_alloc*= 2;
}while(more_log>=change_log_max_alloc);
change_log= (int*)mem_realloc(change_log,sizeof(int)*change_log_max_alloc);
}

/*:75*/
#line 2059 "./jbmr.w"

{int j;
for(j= 1;j<=best_two_i;j++){
write_log(t[j]);
}
}
write_log(best_exit_a);
write_log(best_exit_b);
write_log(scheme_id);
write_log(3+best_two_i);
}


/*:74*/
#line 2020 "./jbmr.w"

/*170:*/
#line 3882 "./jbmr.w"

#if TRACK_DEPTHS
move_depth= 4;
/*178:*/
#line 3936 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 125
if(verbose>=125){
printf("Move_stats: %d %d %d\n",probes,move_depth,probe_depth);
fflush(stdout);
probes++;
}
#endif
#if TRACK_DEPTHS
last_probe_depth= probe_depth;
p_depths[probe_depth]++;
m_depths[move_depth]++;
move_depth= probe_depth= 0;
#endif


/*:178*/
#line 3885 "./jbmr.w"

#endif

/*:170*/
#line 2021 "./jbmr.w"

more_backtracking= 0;
}

/*:72*/
#line 2005 "./jbmr.w"

}

/*:71*/
#line 1403 "./jbmr.w"


/*:45*/
#line 1321 "./jbmr.w"

}
if(best_gain>0){
incumbent_len-= best_gain;
/*140:*/
#line 3486 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 50
if(verbose>=50){
static double last_time= 0.0;
const double this_time= resource_user_tick();
printf("=== improve by "length_t_spec" to "length_t_spec,
length_t_pcast(best_gain),length_t_pcast(incumbent_len));
printf("  after %.3f (+ %.3f) sec\n",this_time,this_time-last_time);
last_time= this_time;
fflush(stdout);
}
#endif


/*:140*/
#line 1325 "./jbmr.w"

/*137:*/
#line 3464 "./jbmr.w"

milestone_check(&ms_lower_bound,incumbent_len);
milestone_check(&ms_upper_bound,incumbent_len);

/*:137*/
#line 1326 "./jbmr.w"

/*54:*/
#line 1546 "./jbmr.w"

#if !(LENGTH_TYPE_IS_EXACT)
instance_epsilon= incumbent_len*LENGTH_MACHINE_EPSILON;
#endif

/*:54*/
#line 1327 "./jbmr.w"

}
}

/*:42*/
#line 776 "./jbmr.w"

}
/*201:*/
#line 4251 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 40
if(verbose>=40){
char end_iter_message[100];
sprintf(end_iter_message,"End of LK step %d",iteration+1);
milestone_show_request(&ms_lower_bound,end_iter_message,incumbent_len);
milestone_show_request(&ms_upper_bound,end_iter_message,incumbent_len);
}
#endif

/*:201*/
#line 778 "./jbmr.w"

/*188:*/
#line 4045 "./jbmr.w"

if(iteration>0&&change_log_next>0&&previous_incumbent_len<incumbent_len){
/*203:*/
#line 4271 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 57
if(verbose>=57){
printf("Reverting to previous\n");
}
#endif

/*:203*/
#line 4047 "./jbmr.w"

while(change_log_next>0){
/*190:*/
#line 4084 "./jbmr.w"

{
const int len= change_log[change_log_next-1],
revert_scheme_id= change_log[change_log_next-2],
first_pos= change_log_next-1-len,
first_generic_pos= first_pos+scheme_num_cities[revert_scheme_id],
t1= change_log[first_pos],*st= (&change_log[first_pos])-1;
int j,si,*s= &scheme[revert_scheme_id][0];
/*204:*/
#line 4279 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 65
if(verbose>=65){
printf("  first_pos = %d change_log_next = %d\n",first_pos,change_log_next);
}
#endif

/*:204*/
#line 4092 "./jbmr.w"

errorif(first_pos<0,"Bug!");
for(j= change_log_next-4;j>=first_generic_pos;j-= 2){
tour_flip_arb(t1,change_log[j+1],change_log[j],change_log[j-1]);
}
for(si= scheme_max[revert_scheme_id]-4;si>=0;si-= 4){
tour_flip_arb(st[s[si]],st[s[si+3]],st[s[si+2]],st[s[si+1]]);
}
}

/*:190*/
#line 4049 "./jbmr.w"

change_log_next-= change_log[change_log_next-1]+1;
}
errorif(change_log_next!=0,"Bug!");
/*200:*/
#line 4244 "./jbmr.w"

{int i;
for(i= 8;i>=0;i-= 4)
tour_flip_arb(mutation[i],mutation[i+3],mutation[i+2],mutation[i+1]);
}

/*:200*/
#line 4053 "./jbmr.w"

incumbent_len= previous_incumbent_len;
}
change_log_next= 0;

/*:188*/
#line 779 "./jbmr.w"

/*191:*/
#line 4107 "./jbmr.w"

if(iteration<iterations-1){
int edge[4][2];
previous_incumbent_len= incumbent_len;
/*192:*/
#line 4120 "./jbmr.w"

{
int ok,count= 0;
do{
int i,j;
errorif(count++>1000,"Ummm, random double-bridge search didn't stop after 1000 tries");
for(i= 0,ok= 1;ok&&i<4;i++){
edge[i][0]= prng_unif_int(random_stream,(long)n);
edge[i][1]= tour_next(edge[i][0]);
for(j= 0;ok&&j<i;j++){
if(edge[j][0]==edge[i][0])ok= 0;
}
}
}while(!ok);
}

/*:192*//*193:*/
#line 4137 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 60
if(verbose>=60){
int i;
printf("Doing double-bridge: ");
for(i= 0;i<4;i++)printf("%d(%d,%d) ",i,edge[i][0],edge[i][1]);
printf("\n");
}
#endif

/*:193*/
#line 4111 "./jbmr.w"

/*194:*/
#line 4154 "./jbmr.w"

{int bottom,rock;
for(bottom= 3;bottom>1;bottom--){
for(rock= 1;rock<bottom;rock++){
if(bridge_less(edge[rock],edge[rock+1])){
swap_bridge(edge[rock],edge[rock+1]);
}
}
}
}


/*:194*/
#line 4112 "./jbmr.w"

/*195:*/
#line 4173 "./jbmr.w"

bridge_move(1,2,6,5);
bridge_move(8,7,4,3);
bridge_move(1,5,2,6);

/*:195*//*196:*/
#line 4183 "./jbmr.w"

{int mutation_next= 0;
mutate(1);
mutate(2);
mutate(6);
mutate(5);

mutate(8);
mutate(7);
mutate(4);
mutate(3);

mutate(1);
mutate(5);
mutate(2);
mutate(6);
}

/*:196*//*197:*/
#line 4207 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 60
#define verbose_print_double_bridge_edge(a,b) \
(verbose >= 60  \
 ? printf("cost(%d,%d)="length_t_spec"\n", \
  bridge_t(a),bridge_t(b),length_t_pcast(cost(bridge_t(a),bridge_t(b)))) \
 : 0 \
)
#define bc(a,b) (verbose_print_double_bridge_edge(a,b),cost(bridge_t(a),bridge_t(b)))
#else
#define bc(a,b) (cost(bridge_t(a),bridge_t(b)))
#endif


incumbent_len+= bc(1,6);
incumbent_len+= bc(2,5);
incumbent_len+= bc(4,7);
incumbent_len+= bc(3,8);
incumbent_len-= bc(1,2);
incumbent_len-= bc(3,4);
incumbent_len-= bc(5,6);
incumbent_len-= bc(7,8);


/*:197*//*198:*/
#line 4232 "./jbmr.w"

{int i;
for(i= 1;i<=8;i++)
mark_dirty(bridge_t(i));
}


/*:198*/
#line 4113 "./jbmr.w"

}
/*202:*/
#line 4262 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 60
if(verbose>=60){
printf("+++incumbent_len is now "length_t_spec"\n",length_t_pcast(incumbent_len));
}
#endif


/*:202*/
#line 4115 "./jbmr.w"




/*:191*/
#line 780 "./jbmr.w"

}
/*141:*/
#line 3501 "./jbmr.w"

#if JBMR_MAX_VERBOSE >= 20
if(verbose>=20){
const double lk_time= resource_user_tick();
const double ds_time= resource_user_tick_from(begin_data_structures_mark);
printf("LK phase ended with incumbent_len == "length_t_spec
" after %.3f sec for LK and %.3f sec for ds+LK\n",
length_t_pcast(incumbent_len),lk_time,ds_time);
fflush(stdout);
}
#endif

/*:141*/
#line 782 "./jbmr.w"

/*138:*/
#line 3469 "./jbmr.w"

milestone_show_final(&ms_lower_bound,incumbent_len);
milestone_show_final(&ms_upper_bound,incumbent_len);

/*:138*/
#line 783 "./jbmr.w"

/*19:*/
#line 724 "./jbmr.w"

dirty_destroy(dirty_set);

/*:19*//*25:*/
#line 829 "./jbmr.w"

free_mem(t);

/*:25*//*49:*/
#line 1461 "./jbmr.w"

free_mem(e[0]);
free_mem(e[1]);
free_mem(e[2]);
free_mem(e[3]);

/*:49*//*77:*/
#line 2088 "./jbmr.w"

free_mem(change_log);


/*:77*//*116:*/
#line 3196 "./jbmr.w"

#if defined(TABU_SPLAY)
dict_destroy(tabu);
#endif

/*:116*//*133:*/
#line 3435 "./jbmr.w"

#if defined(TABU_HASH)
if(tabu_hash_destroy)tabu_hash_destroy(tabu_hash);
#endif

/*:133*/
#line 784 "./jbmr.w"

/*184:*/
#line 3997 "./jbmr.w"

/*183:*/
#line 3981 "./jbmr.w"

#if TRACK_DEPTHS
{int i,j;
for(i= DEPTHS_BOUND-1;p_depths[i]!=0;i--);
for(j= 0;j<=i;j++){
if(p_depths[j])printf("p %d citydeep %d\n",j,p_depths[j]);
}
for(i= DEPTHS_BOUND-1;m_depths[i]!=0;i--);
for(j= 0;j<=i;j++){
if(m_depths[j])printf("m %d citydeep %d\n",j,m_depths[j]);
}
}
#endif


/*:183*/
#line 3998 "./jbmr.w"

printf("Statistics: num_reject_by_cum_1 %d\n",num_reject_by_cum_1);
printf("Statistics: num_reject_pre_e_build %d\n",num_reject_pre_e_build);
printf("Statistics: num_reject_by_decluster %d\n",num_reject_by_decluster);


/*:184*/
#line 785 "./jbmr.w"

}

/*:21*/
#line 596 "./jbmr.w"

const char*jbmr_rcs_id= "$Id: jbmr.w,v 1.203 1998/10/02 19:14:06 neto Exp neto $";

/*:4*/
